--[[
	## BoTD Group WoW Classic Addon 
	## 10/9/2019
	## Brandon Autry
	## brandon@bitdraft.com
	## Vers: [Beta v0.3.2.6]
	## botdcore.lua 
	]] --

--------------------------------------
-- Namespaces
--------------------------------------
local addonName, botdcore = ...

-- /console scriptErrors 1
-- For colors just add cFF in front of the #FF8C00 <- Hex DarkOrange
-- Addon logging information when character enters world.

--[[
### IDEAS: See whos loot is whos, a party request queue, a guild whisper party accept, timer for macro, see entities hit points

--- NEED TO TRY THIS: Many (but not all) API functions that accept a unitID also accept the name of a unit (assuming that unit is in the player's party or raid). For example, UnitHealth("Cladhaire") will return the same value as UnitHealth("party1") if the unit party1 is the player named Cladhaire. In such situations, a unit's target can still be accessed by appending "-target"; e.g. UnitHealth("Cladhaire-target").
--status = UnitThreatSituation(unit [, mobUnit])



##Useful info f:SetFrameStrata("BACKGROUND")
### --power = UnitPower("unitID", 0) - Alert party members when "Priest" is running low on mana
## -- Hypothetical communication using addon messages
local MSG_PREFIX = "MY_MOD"
SendAddonMessage(MSG_PREFIX, "Resync", "GUILD")
SendAddonMessage(MSG_PREFIX, "VersionCheck", "WHISPER", "username")
]]
--[[
	## Global Variables
	]]
-- Ints
PreviousY = -28
GuildOnlineCount = 0
RefreshFriends = 1
RefreshFriendsLonger = 3
guildCount = 0
guildCount = 0
guildCountOnline = 0
guildCurrentCountOnline = 0
botdcore.alertKillCount = true
-- Local Variables
local total = 0 -- OnUpdate Variable
local totalLonger = 0 -- OnUpdate Variable

LostPartyLeader = true
-- Booleans
ResetFPS = false
playerExists = false
didSayBuffA = false
showmenu = false
pLeader = false
-- Frame Variables
fps = nil
PlayerLeavePartyButton = nil
-- Tables
local framepool = {}
local vars = {}

local zoneTbl = {}
local framepoolZone = {}

varsFollowBtns = {}
varsGroupBtns = {}
afkList = {}
guildList = {}

partyLeaders = {}
botdcore.GuildOnlinePlayerList = {}
playersaddedToGui = {}
currentlyOnline = {}
MyPlayer = nil
-- Text colors
orange = "|cffFF8C00"
darkgrey = "|cffA9A9A9"
purple = "|cff8A2BE2"
white = "|cFFFFFFFF"
red = "|cFFFF0000"
green = "|cFF4ddb00"
blue = "|cFF0099ff"

druidColor = "|cFFFF7D0A"
mageColor = "|cFF69CCF0"
paladinColor = "|cFFF58CBA"
warriorColor = "|cFFC79C6E"
hunterColor = "|cFFABD473"
warlockColor = "|cFF9482C9"
priestColor = "|cFFFFFFFF"
rogueColor = "|cFFFFF569"

-- Strings
version = "[0.3.2.6]" --Version Number
whispered = ""
invitePlayer = ""
PreviousZone = ""
networkstats = "NetworkStats"
--Frames

-- Slash Commands
SLASH_RELOADUI1 = "/r1" -- For Quicker reloading
SlashCmdList.RELOADUI = ReloadUI

SLASH_FRAMESTK1 = "/fs" -- For Quicker access to frame stack
SlashCmdList.FRAMESTK = function()
	LoadAddOn("Blizzard_DebugTools")
	FrameStackTooltip_Toggle()
end

SlashCmdList.CLEAR_CHAT = function()
	for i = 1, NUM_CHAT_WINDOWS do
		_G[format("ChatFrame%d", i)]:Clear()
	end -- End for LOOP
end
SLASH_CLEAR_CHAT1 = "/clear"

for i = 1, NUM_CHAT_WINDOWS do
	_G["ChatFrame" .. i .. "EditBox"]:SetAltArrowKeyMode(false)
end -- End for LOOP

local function HandleSlashCommands(str)
	if (#str == 0) then
		if (UIConfig == nil) then
			-- CreateMenu()
		elseif (UIConfig:IsVisible() == true) then
			UIConfig:Hide()
			for inde, valu in ipairs(framepoolZone) do
				if (valu:IsVisible() or valu:IsShown()) then
					valu:Hide()
					valu.ZoneLevel.text:Hide()
				end -- End for LOOP
			end
			showmenu = false
		else
			UIConfig:Show()
			-- MyZoneFrame:Show()
			for inde, valu in ipairs(framepoolZone) do
				if (not valu:IsVisible() or not valu:IsShown()) then
					valu:Show()
					valu.ZoneLevel.text:Show()
				end
			end -- End for LOOP
			showmenu = true
		end -- End (UIConfig == nil) STMT
	end -- End if (#str == 0) STMT
end --End HandleSlashCommands FUNCTION

SLASH_botd1 = "/menu"
SlashCmdList.botd = HandleSlashCommands
---------------------------------------------------------------------------------------------------

--[[
	## Functions
]]
function GetTableCount(table)
	count = 0
	for inde1, player1 in ipairs(table) do
		count = count + 1
	end
	return count
end

local function SearchTableForValue(chTable, characterName)
	for checkInd, checkVal in ipairs(chTable) do
		if (characterName == checkVal) then
			return true
		end -- (characterName == checkVal) STMT
	end -- End for LOOP
	return false
end -- End lcl SearchTableForValue Function

function botdcore.SearchTableForValueByIndex(chTable, value)
	for checkInd, checkVal in ipairs(chTable) do
		if (value == checkInd) then
			return true
		end -- (characterName == checkVal) STMT
	end -- End for LOOP
	return false
end -- End lcl SearchTableForValue Function

local function SearchTableForPlayerName(chTable, characterName)
	for checkInd, checkVal in ipairs(chTable) do
		if (characterName == checkVal.name) then
			return true
		end -- (characterName == checkVal) STMT
	end -- End for LOOP
	return false
end -- End lcl SearchTableForValue Function

function AddFramePool(frame)
	table.insert(framepool, frame)
end

function AddZoneFramePool(frame)
	table.insert(framepoolZone, frame)
end
local function GuildListGui(player)

	heightUi = UIConfig:GetHeight()
	widthUi = UIConfig:GetWidth()
	content1:SetWidth(widthUi)
	-- content1:SetHeight(heightUi)
	if (GuildOnlineCount == 0) then
		GuildOnlineCount = GuildOnlineCount + 1
	else
		PreviousY = PreviousY - 20
		GuildOnlineCount = GuildOnlineCount + 1
	end

	if (UnitName("player") ~= player) then
		vars[player] = botdcore.PartyMemberListFollow(player, "LEFT", content1, "TOPLEFT", 7, PreviousY, orange .. player)
		vars[player]:SetWidth(widthUi)
		vars[player]:EnableMouse(true)
	else
		vars[player] = botdcore.PartyMemberListFollow(player, "LEFT", content1, "TOPLEFT", 7, PreviousY, green .. player)
		vars[player]:SetWidth(widthUi)
		vars[player]:EnableMouse(true)
	end

	AddFramePool(vars[player])

	if (UnitName("player") ~= player) then
		-- GuildMemBtnf = CreateFrame("Button", nil, vars[player], "GameMenuButtonTemplate")
		-- GuildMemBtnf:SetPoint("LEFT", content1, "TOPLEFT", 180, PreviousY)
		-- GuildMemBtnf:SetSize(42, 20)
		-- GuildMemBtnf:SetText("Group")
		-- GuildMemBtnf:SetNormalFontObject("GameFontNormalSmall")
		-- GuildMemBtnf:SetHighlightFontObject("GameFontNormalSmall")
		-- GuildMemBtnf:SetScript(
		-- 	"OnClick",
		-- 	function()
		-- 		if (IsInGroup() == false) then
		-- 			whispered = ".$botd_jp_!"
		-- 			SendChatMessage(".$botd_jp_!", "WHISPER", nil, player)
		-- 		else
		-- 			whispered = ".$botd_ap_!"
		-- 			SendChatMessage(".$botd_ap_!", "WHISPER", nil, player)
		-- 			InviteUnit(player)
		-- 		end
		-- 	end
		-- )
		varsFollowBtns[player] = CreateFrame("Button", nil, vars[player], "GameMenuButtonTemplate")
		AddFramePool(varsFollowBtns[player])
		varsFollowBtns[player]:SetPoint("RIGHT", vars[player], "RIGHT", -68, 0)
		varsFollowBtns[player]:SetSize(43, 20)
		varsFollowBtns[player]:SetText("Follow")
		varsFollowBtns[player]:SetNormalFontObject("GameFontNormalSmall")
		varsFollowBtns[player]:SetHighlightFontObject("GameFontNormalSmall")

		varsFollowBtns[player]:SetScript(
			"OnClick",
			function()
				print("Following: " .. player)
				FollowUnit(player)
			end
		)

		varsGroupBtns[player] = CreateFrame("Button", nil, vars[player], "GameMenuButtonTemplate")
		AddFramePool(varsGroupBtns[player])
		varsGroupBtns[player]:SetPoint("RIGHT", vars[player], "RIGHT", -20, 0)
		varsGroupBtns[player]:SetSize(42, 20)
		varsGroupBtns[player]:SetText("Group")
		varsGroupBtns[player]:SetNormalFontObject("GameFontNormalSmall")
		varsGroupBtns[player]:SetHighlightFontObject("GameFontNormalSmall")

		varsGroupBtns[player]:SetScript(
			"OnClick",
			function()
				if (IsInGroup() == false) then
					whispered = ".$botd_jp_!"
					SendChatMessage(".$botd_jp_!", "WHISPER", nil, player)
				else
					whispered = ".$botd_ap_!"
					SendChatMessage(".$botd_ap_!", "WHISPER", nil, player)
					InviteUnit(player)
				end
			end
		)
	else
		DisbanPartyButton = CreateFrame("Button", nil, vars[player], "GameMenuButtonTemplate")
		DisbanPartyButton:SetPoint("RIGHT", vars[player], "RIGHT", -68, 0)
		DisbanPartyButton:SetSize(52, 20)
		DisbanPartyButton:SetText("Disband")
		DisbanPartyButton:SetNormalFontObject("GameFontNormalSmall")
		DisbanPartyButton:SetHighlightFontObject("GameFontNormalSmall")
		DisbanPartyButton:Hide()
		DisbanPartyButton:SetScript(
			"OnClick",
			function()
				local names = GetHomePartyInfo()
				for indthree, valthree in ipairs(names) do
					if (valthree ~= UnitName("player")) then
						UninviteUnit(valthree, "BYEEEEEEEEEEEE")
					end
				end
			end
		)
		PlayerLeavePartyButton = CreateFrame("Button", nil, vars[player], "GameMenuButtonTemplate")
		PlayerLeavePartyButton:SetPoint("RIGHT", vars[player], "RIGHT", -20, 0)
		PlayerLeavePartyButton:SetSize(43, 20)
		PlayerLeavePartyButton:SetText("Leave")
		PlayerLeavePartyButton:SetNormalFontObject("GameFontNormalSmall")
		PlayerLeavePartyButton:SetHighlightFontObject("GameFontNormalSmall")
		PlayerLeavePartyButton:Hide()
		PlayerLeavePartyButton:SetScript(
			"OnClick",
			function()
				LeaveParty()
			end
		)
	end
end

local output = ""
local f = CreateFrame("Frame")

local function RoLwriteGuild()
	f:RegisterEvent("GUILD_ROSTER_UPDATE")
	GuildRoster()
end

f:SetScript(
	"OnEvent",
	function(f)
		f:UnregisterEvent("GUILD_ROSTER_UPDATE")
		local numTotal = (GetNumGuildMembers(true))
	end
)

function botdcore.CreateOnlinePlayerList()
	RoLwriteGuild()
	for i = 1, GetNumGuildMembers() do
		fullName,
			rank,
			rankIndex,
			level,
			class,
			zone,
			note,
			officernote,
			online,
			status,
			classFileName,
			achievementPoints,
			achievementRank,
			isMobile,
			canSoR,
			reputation = GetGuildRosterInfo(i)
		name, realm = strsplit("-", fullName)
		if (online) then
			localPlayer =
				botdcore.BotdPlayer:Create(
				fullName,
				rank,
				rankIndex,
				level,
				class,
				zone,
				note,
				officernote,
				online,
				status,
				classFileName,
				achievementPoints,
				achievementRank,
				isMobile,
				canSoR,
				reputation
			)
			check = SearchTableForPlayerName(botdcore.GuildOnlinePlayerList, name)
			if (check == false) then
				table.insert(botdcore.GuildOnlinePlayerList, localPlayer)
				GuildListGui(localPlayer.name)
				--Inform of party lead
				local uLeads = UnitLeadsAnyGroup("player")
				inparty = UnitInParty(name)
				if (online and inparty == false and UnitName("player") ~= name and uLeads) then
				-- SendChatMessage(".$botd_ptyLd_!", "WHISPER", nil, name)
				end
			else
				for i = 1, GetNumGuildMembers() do
					fullName,
						rank,
						rankIndex,
						level,
						class,
						zone,
						note,
						officernote,
						online,
						status,
						classFileName,
						achievementPoints,
						achievementRank,
						isMobile,
						canSoR,
						reputation = GetGuildRosterInfo(i)
					charName, realm = strsplit("-", fullName)
					--If player is online then add them to a table

					for tmpindex, tmpplayer in ipairs(botdcore.GuildOnlinePlayerList) do
						if (charName == tmpplayer.name) then
							tmpplayer.status = status
							tmpplayer.level = level
							tmpplayer.zone = zone
							tmpplayer.online = online
						end
					end
				end
			end
		else
			check = SearchTableForPlayerName(botdcore.GuildOnlinePlayerList, name) -- check to see if this offline player is in list
			if check == true and online == false then
				for inde, player in ipairs(botdcore.GuildOnlinePlayerList) do
					-- table.remove(botdcore.GuildOnlinePlayerList, inde)
					PreviousY = -28
					GuildOnlineCount = 0
					for inde, valu in ipairs(framepool) do
						valu:Hide()
					end -- End for LOOP
					framepool = {}

					botdcore.GuildOnlinePlayerList = {}
					playersaddedToGui = {}
					botdcore.CreateOnlinePlayerList()
				end
			end
		end
	end
	-- return LocalOnlinePlayers
end

--check if string starts with something
function starts_with(str, start)
	return str:sub(1, #start) == start
end

--So This will allow us to auto accept people into our party that whisper us some catch fraze ".botd_jp"
UIConfig.friendInvite = CreateFrame("Frame")
UIConfig.friendInvite:RegisterEvent("CHAT_MSG_WHISPER")
UIConfig.friendInvite:SetScript(
	"OnEvent",
	function(self, event, arg1, arg2)
		if (arg1:lower():match(".$botd_jp_!")) then
			whispered = ".$botd_jp_!"
			invitePlayer = arg2
			BoTDInviteGuildParty(arg2, whispered)
		end
		if (arg1:lower():match(".$botd_ap_!")) then
			whispered = ".$botd_ap_!"
			invitePlayer = arg2
			BoTDInviteGuildParty(arg2, whispered)
		end

		split = starts_with(arg1:lower(), ".fwith")
		if (split) then
			cmd, emote = strsplit("-", arg1)
			DoEmote(emote)
		end
		spaynow = starts_with(arg1:lower(), ".fsay")
		if (spaynow) then
			charName, say = strsplit("-", arg1)
			SendChatMessage(say, "GUILD", nil, UnitName("player"))
		end
		if (arg1:match(".$botd_ptyLd_!")) then
			charName, realm = strsplit("-", arg2)
			table.insert(partyLeaders, charName)
		end

		if (arg1:match(".$botd_followme_!")) then
			charName, realm = strsplit("-", arg2)
			if(ALLOWFOLLOWVAR) then
				FollowUnit(charName)
				-- if UnitIsAFK("player") then
				-- 	SendChatMessage("REMOVING AFK.", "WHISPER", nil, arg2)
				-- end
			else
				SendChatMessage("I currently have allow auto follow disabled.", "WHISPER", nil, arg2)

			end
		end
		--   /w bossjoker .fwith-dance,bastet
		--   /w bossjoker .botdPwd
	end
)

function table.empty(self)
	for _, _ in pairs(self) do
		return false
	end
	return true
end

local f = CreateFrame("Frame")

local function OnEvent(self, event)
	if event == "PARTY_INVITE_REQUEST" and (whispered == ".$botd_jp_!" or whispered == ".$botd_ap_!") then
		AcceptGroup()
		StaticPopup_Hide("PARTY_INVITE")

		f:RegisterEvent("GROUP_ROSTER_UPDATE")
	elseif event == "GROUP_ROSTER_UPDATE" then
		StaticPopup_Hide("PARTY_INVITE")

		f:UnregisterEvent("GROUP_ROSTER_UPDATE")
	end
end

f:RegisterEvent("PARTY_INVITE_REQUEST")
f:SetScript("OnEvent", OnEvent)
-- function to add player to party if AutoInvitePlayers is set to true
function BoTDInviteGuildParty(playerName, whisp)
	name, realm = strsplit("-", playerName)
	invitePlayer = name

	-- print(invitePlayer)
	if (AutoInvitePlayers == true) then
		if (whisp == ".$botd_jp_!") then
			InviteUnit(invitePlayer)
		elseif (whisp == ".$botd_ap_!") then
			local f = CreateFrame("Frame")

			local function OnEvent(self, event)
				if event == "PARTY_INVITE_REQUEST" and (whisp == ".$botd_jp_!" or whisp == ".$botd_ap_!") then
					AcceptGroup()
					StaticPopup_Hide("PARTY_INVITE")

					f:RegisterEvent("GROUP_ROSTER_UPDATE")
				elseif event == "GROUP_ROSTER_UPDATE" then
					StaticPopup_Hide("PARTY_INVITE")

					f:UnregisterEvent("GROUP_ROSTER_UPDATE")
				end
			end
			f:RegisterEvent("PARTY_INVITE_REQUEST")
			f:SetScript("OnEvent", OnEvent)
		end
	else
		SendChatMessage(
			UnitName("player") .. " currently has the [BoTD]auto-party feature disabled.",
			"WHISPER",
			nil,
			playerName
		)
	end
end

function ShowDunMap(czone)
	if (czone == "The Deadmines") then
		mapTexture:SetTexture("Interface\\Addons\\BoTD\\modules\\deadminesmap")
	elseif (czone == "Stormwind Stockade") then
		mapTexture:SetTexture("Interface\\Addons\\BoTD\\modules\\stockademap")
	elseif (czone == "Razorfen Kraul") then
		mapTexture:SetTexture("Interface\\Addons\\BoTD\\modules\\rfkmap")
	elseif (czone == "Gnomeregan") then
		mapTexture:SetTexture("Interface\\Addons\\BoTD\\modules\\gnomeregan")
	elseif (czone == "Shadowfang Keep") then
		mapTexture:SetTexture("Interface\\Addons\\BoTD\\modules\\resources\\sfk")
	elseif (czone == "Blackfathom Deeps") then
		mapTexture:SetTexture("Interface\\Addons\\BoTD\\modules\\resources\\bfd")
	elseif (czone == "Scarlet Monastery") then
		mapTexture:SetTexture("Interface\\Addons\\BoTD\\modules\\resources\\scarlet")
	end
end

local function SearchForInstance(instanceTable, zone)
	for checkInd, checkVal in ipairs(instanceTable) do
		if (zone == checkVal) then
			return true
		end -- (characterName == checkVal) STMT
	end -- End for LOOP
	return false
end -- End lcl SearchTableForValue Function

function ZoneTextandNetworkText(player)
	if PreviousZone ~= player.zone or PreviousZone == "" then
		-- if (table.empty(zoneTbl) == false) then
		-- if zoneTbl[player.zone] ~= nil and zoneTbl[player.zone].ZoneLevel ~= nil then
		for inde, valu in ipairs(framepoolZone) do
			valu:Hide()
			valu.ZoneLevel.text:Hide()
		end -- End for LOOP

		zoneTbl = {}
		framepoolZone = {}
		-- end
		PreviousZone = player.zone
		-- zoneTbl[player.zone] = CreateFrame("Frame")
		if (player.zone ~= nil) then
			zoneTbl[player.zone] = CreateFrame("Frame", nil, WorldFrame, "ShadowOverlaySmallTemplate")
			zoneTbl[player.zone]:SetBackdrop(StaticPopup1:GetBackdrop())

			-- zoneTbl[player.zone]:SetBackdrop(StaticPopup1:GetBackdrop())
			zoneTbl[player.zone]:SetHeight(65)
			zoneTbl[player.zone]:SetWidth(265)
			zoneTbl[player.zone].text = zoneTbl[player.zone]:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
			zoneTbl[player.zone]:SetPoint("CENTER", UIConfig, "TOP", 0, 25) -- point, relativeFrame, relativePoint, xOffset, yOffset
			zoneTbl[player.zone]:SetFrameStrata("MEDIUM")

			AddZoneFramePool(zoneTbl[player.zone])

			zoneTbl[player.zone].ZoneLevel = CreateFrame("Frame")
			zoneTbl[player.zone].ZoneLevel.text = zoneTbl[player.zone]:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
			zoneTbl[player.zone].ZoneLevel.text:SetPoint("CENTER", zoneTbl[player.zone], "CENTER", 0, 0)
			zoneTbl[player.zone].ZoneLevel.text:SetText("")
			zoneTbl[player.zone]:SetFrameStrata("MEDIUM")
		end
		-- if (botdcore.PlayerProfessionOne == "Mining" or botdcore.PlayerProfessionTwo == "Mining") then
		-- 	zoneTbl[player.zone].ZoneLevel.text:SetText(
		-- 		player.zone .. zoneMinMax[player.zone] .. "\n" .. GetMinimapZoneText() .. zoneMiningMinMax[player.zone]
		-- 	)
		-- else
		-- 	zoneTbl[player.zone].ZoneLevel.text:SetText(player.zone .. zoneMinMax[player.zone] .. "\n" .. GetMinimapZoneText())
		-- end

	if (zoneMiningMinMax[player.zone] == nil) then
		botdcore.ShowMiningLocations()
		botdcore.GetProfessions()
	end
	

		if ((botdcore.PlayerProfessionOne == "Mining" or botdcore.PlayerProfessionTwo == "Mining") and (zoneMinMax[player.zone] ~= nil and zoneMiningMinMax[player.zone] ~= nil)) then
			miningText = zoneMiningMinMax[GetMinimapZoneText()]
			if (miningText ~= "" and miningText ~= nil) then
				miningText = zoneMiningMinMax[player.zone]
				zoneTbl[player.zone].ZoneLevel.text:SetText(mageColor.. GetMinimapZoneText().. "|r, "..white..
				player.zone .."|r"..white..zoneMinMax[player.zone] .. white..zoneMiningMinMax[GetMinimapZoneText()])
			else
				zoneTbl[player.zone].ZoneLevel.text:SetText(mageColor.. GetMinimapZoneText().. "|r, "..white..
				player.zone .."|r"..white..zoneMinMax[player.zone] .. white..zoneMiningMinMax[player.zone])
			end
			
		else
			if (zoneMinMax[player.zone] ~= nil) then
				zoneTbl[player.zone].ZoneLevel.text:SetText(mageColor.. GetMinimapZoneText().. "|r, "..white..
			player.zone .."|r"..white..zoneMinMax[player.zone])
			else
				zoneTbl[player.zone].ZoneLevel.text:SetText(mageColor.. GetMinimapZoneText().. "|r, "..white..
				player.zone .."|r")
			end
			
		end



		--Network Information
		bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
		if network ~= nil then
			network.text:Hide()
			network:Hide()
		end
		network = CreateFrame("Frame")

		network.text = content4:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
		network.text:SetPoint("CENTER", content4, "BOTTOM", 0, 60)
		if bandwidthIn ~= nil and bandwidthOut ~= nil  then
			network.text:SetText(
			"World Latency: " ..
				latencyWorld ..
					"\nHome Latency: " .. latencyHome .. "\nBandwidth In: " .. botdcore.roundDec(bandwidthIn, 1) .. "\nBandwidth Out: " .. botdcore.roundDec(bandwidthOut, 1)
		)
		end
		
		
		
		--Rest State
		currReststate, restname, restmultiplier = GetRestState()

		if RestState ~= nil then
			RestState.text:Hide()
			RestState:Hide()

			RestStateBars.text:Hide()
			RestStateBars:Hide()

			RestStateBarsToDing.text:Hide()
			RestStateBarsToDing:Hide()
		end
		
		RestState = CreateFrame("Frame")
		RestState.text = content2:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
		RestState.text:SetJustifyH("LEFT")
		heightUi = UIConfig:GetHeight()
		widthUi = UIConfig:GetWidth()
		content2:SetWidth(widthUi)
		content2:SetHeight(heightUi)
		
		RestState.text:SetPoint("LEFT", content2, "BOTTOMLEFT", 15, 42)
		restStateDesc = ""

		RestStateBars = CreateFrame("Frame")
		RestStateBars.text = content2:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
		RestStateBars.text:SetJustifyH("RIGHT")
		RestStateBars.text:SetPoint("CENTER", content2, "BOTTOM", -13, 42)
		-- restStateDesc = ""


		RestStateBarsToDing = CreateFrame("Frame")
		RestStateBarsToDing.text = content2:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
		RestStateBarsToDing.text:SetJustifyH("CENTER")
		RestStateBarsToDing.text:SetPoint("RIGHT", content2, "BOTTOMRIGHT", -15, 42)
		-- restStateDesc = ""
		
		-- RestState.text:SetText(
		-- 	restname .. "\n-Experience multiplier: " .. restmultiplier .. "x/per kill."

		
		-- )
	end
	-- end
end

function PlayerInfoOnHover()
	PlayerInfoOnHoverFrame = CreateFrame("Frame", nil, UIConfig, "StatFrameTemplate")
	-- UIConfig.PlayerInfoOnHoverFrame:ClearAllPoints()
	PlayerInfoOnHoverFrame:SetBackdrop(StaticPopup1:GetBackdrop())
	PlayerInfoOnHoverFrame:SetHeight(80)
	PlayerInfoOnHoverFrame:SetWidth(370)
	PlayerInfoOnHoverFrame.text = PlayerInfoOnHoverFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	PlayerInfoOnHoverFrame:SetClipsChildren(true)

	-- PlayerInfoOnHoverFrame.text:SetPoint("TOPLEFT", 15, -15)
	-- PlayerInfoOnHoverFrame.text:SetJustifyH("LEFT")
	PlayerInfoOnHoverFrame.text:SetAllPoints()
	PlayerInfoOnHoverFrame.text:SetNonSpaceWrap(true)
	PlayerInfoOnHoverFrame:SetFrameStrata("HIGH")
	PlayerInfoOnHoverFrame.text:SetWidth(75)
	PlayerInfoOnHoverFrame.text:SetHeight(80)
end

local function CheckBuffListTable(playerName)
	tempBuffList = {}

	for i = 1, 40 do
		buffInList = false
		name,
			rank,
			icon,
			count,
			dispelType,
			duration,
			expires,
			caster,
			isStealable,
			nameplateShowPersonal,
			spellID,
			canApplyAura,
			isBossDebuff,
			_,
			nameplateShowAll,
			timeMod,
			value1,
			value2,
			value3 = UnitBuff(playerName, i)
		if name then
			for inde, valu in ipairs(tempBuffList) do
				if (valu == name) then
					buffInList = true
				end
			end
			if (buffInList == true) then
			else
				table.insert(tempBuffList, name)
				buffInList = false
			end
		end
	end
	return tempBuffList
end

function GetClassColor(class)
	charColor = ""
	if (class == "Warrior") then
		charColor = warriorColor
	elseif (class == "Warlock") then
		charColor = warlockColor
	elseif (class == "Hunter") then
		charColor = hunterColor
	elseif (class == "Priest") then
		charColor = priestColor
	elseif (class == "Druid") then
		charColor = druidColor
	elseif (class == "Rogue") then
		charColor = rogueColor
	elseif (class == "Paladin") then
		charColor = paladinColor
	elseif (class == "Mage") then
		charColor = mageColor
	end

	return charColor
end
function botdcore.ClickedOnPlayer(playerName, button)
	if (button == "LeftButton") then
		canTrade = CheckInteractDistance(playerName, 2)
		if (canTrade) then
			if (UnitName("player") == playerName) then
				print(orange .. "[BoTD] " .. version .. "|r " .. red .."I'm afraid you can't trade with yourself.")
			else
			print(orange .. "[BoTD] " .. version .. "|r " .. "Initiated trade with: " .. purple .. playerName .. "|r.")
			InitiateTrade(playerName)
			end
		else
			print(orange .. "[BoTD] " .. version .. "|r " ..  red .. playerName .. " is too far away to trade with.|r")
		end
	elseif (button == "RightButton") then
		SendChatMessage(".$botd_followme_!", "WHISPER", nil, playerName)
		
		-- print(orange .. "[BoTD] " .. version .. "|r " .. "Right clicked on: "..purple..playerName.."|r. This feature is coming soon!")
	end
end

prevMoney = botdcore.money
--Timer/Game loop every 1 Frames
function OnUpdate(self, elapsed)
	-- UIConfig:SetSize(235, 220) -- width, height
	-- honorKills, honorPoints = GetPVPSessionStats()
	-- honorKillsYst, honorPointsYst = GetPVPYesterdayStats()
	-- content3.PvPInfo.text:SetText("PvP Kills Yesterday: "..honorKillsYst.."\nPvP Kills this session: "..honorKills)

	if (UIConfig:IsVisible() or UIConfig:IsShown()) then
		for inde, valu in ipairs(framepoolZone) do
			if (not valu:IsVisible() or not valu:IsShown()) then
				valu:Show()
				valu.ZoneLevel.text:Show()
			end
		end -- End for LOOP
	else
		for inde, valu in ipairs(framepoolZone) do
			if (valu:IsVisible() or valu:IsShown()) then
				valu:Hide()
				valu.ZoneLevel.text:Hide()
			end -- End for LOOP
		end
	end
	if (not MapFrame:IsShown() or not MapFrame:IsVisible()) then
		ShowDungeonMp = false
		mapTexture:Hide()
		ShowDungeonMap:SetText("Show Map")
		MyInstanceKeyFrame:Hide()
		MyInstanceKeyFrame.InstanceKey.text:Hide()
		
	end

	isInstance, instanceType = IsInInstance()
	checkInstance = SearchForInstance(botdcore.instances, GetZoneText())
	if (checkInstance == false) then
		MapFrame:Hide()
		ShowDungeonMp = false
		mapTexture:Hide()
		ShowDungeonMap:Hide()

		MyInstanceKeyFrame:Hide()
		MyInstanceKeyFrame.InstanceKey.text:Hide()
		content2.DungeonButtonText:Hide()
		content2.DungeonButtonText.text:Hide()
	elseif (checkInstance == true) then
		content2.DungeonButtonText.text:Show()
		ShowDungeonMap:Show()
	end


	--Every 1 frame
	total = total + elapsed
	totalLonger = totalLonger + elapsed

	if ALLOWFOLLOWVAR then
		content4.checkAllowFollow:SetChecked(true)
	else
		content4.checkAllowFollow:SetChecked(false)
	end

	if ANNOUNCEMANAWARNING then
		content4.partyManaWarning:SetChecked(true)
	else
		content4.partyManaWarning:SetChecked(false)
	end

	if PROMOTE_LEADER then
		content4.promoteToLeader:SetChecked(true)
	else
		content4.promoteToLeader:SetChecked(false)
	end
	
	-- botdcore.TotalCooldownList()
	if total >= RefreshFriends then
		if (ANNOUNCEMANAWARNING) then
			botdcore.CheckManaLevel()
		end
		--FPS
		framerate = GetFramerate()
		myfps = botdcore.Round(framerate)
		if (fps == nil) then
			fps =
				botdcore.PartyMemberListFollow(
				"FPS",
				"TOPRIGHT",
				UIConfig,
				"TOPRIGHT",
				0,
				-11,
				orange .. "FPS: |r" .. white .. myfps .. "|r"
			)
			botdcore.displayupdate(orange .. "FPS: |r" .. "|cFFFFFFFF" .. myfps .. "|r")
		else
			botdcore.displayupdate(orange .. "FPS: |r" .. "|cFFFFFFFF" .. myfps .. "|r")
		end
		local playerLeader = UnitLeadsAnyGroup("player")

		--Check to see if character is in a guild
		local money = GetMoney()
		if (prevMoney ~= money) then
			moneyFormatted =
				("|cFFFFD700%dg|r |cFFC0C0C0%ds|r |cFFb87333%dc|r"):format(money / 100 / 100, (money / 100) % 100, money % 100)
			content1.mygold1.text:SetText("")
			content2.mygold2.text:SetText("")
			content3.mygold3.text:SetText("")
			content1.mygold1.text:SetText(moneyFormatted)
			content2.mygold2.text:SetText(moneyFormatted)
			content3.mygold3.text:SetText(moneyFormatted)
			prevMoney = money
		end
		-- nameOne = UnitHealth("Dealbreaker")
		-- if (nameOne ~= 0 and nameOne ~= nil) then
		-- 	print("Hey " .. nameOne)
		-- end
		--Check if buff is expired or expiring

		if (profOneString == "" or profTwoString == "" or profThreeString == "" or profFourString == "" or profFiveString == "") then
			botdcore.GetProfessions()
			if(botdcore.PlayerProfessionOne ~= nil and botdcore.PlayerProfessionOne ~= "") then
				profOneString = "Professions:\n" .. botdcore.PlayerProfessionOne .. " - " .. botdcore.PlayerProfessionOneLvl.." - "..botdcore.GetProfessionLevel(botdcore.PlayerProfessionOne)
			end
			if(botdcore.PlayerProfessionTwo ~= nil and botdcore.PlayerProfessionTwo ~= "") then
				profTwoString = botdcore.PlayerProfessionTwo .. " - " .. botdcore.PlayerProfessionTwoLvl.." - "..botdcore.GetProfessionLevel(botdcore.PlayerProfessionTwo)
			end
			if (botdcore.PlayerProfessionThree ~= nil and botdcore.PlayerProfessionThree ~= "") then
				profThreeString = botdcore.PlayerProfessionThree .. " - " .. botdcore.PlayerProfessionThreeLvl.." - "..botdcore.GetProfessionLevel(botdcore.PlayerProfessionThree)
			end
			if (botdcore.PlayerProfessionFour ~= nil and botdcore.PlayerProfessionFour ~= "") then
				profFourString = botdcore.PlayerProfessionFour .. " - " .. botdcore.PlayerProfessionFourLvl.." - "..botdcore.GetProfessionLevel(botdcore.PlayerProfessionFour)
			end
			if (botdcore.PlayerProfessionFive ~= nil and botdcore.PlayerProfessionFive ~= "") then
				profFiveString = botdcore.PlayerProfessionFive .. " - " .. botdcore.PlayerProfessionFiveLvl.." - "..botdcore.GetProfessionLevel(botdcore.PlayerProfessionFive)
			end


			if (botdcore.PlayerProfessionOne == "Herbalism" or botdcore.PlayerProfessionOne == "Mining") then
				local skill = botdcore.GetProfessionLevel(botdcore.PlayerProfessionOne)
				profOneString = botdcore.PlayerProfessionOne .. " - " ..skill
			end
			if (botdcore.PlayerProfessionTwo == "Herbalism" or botdcore.PlayerProfessionTwo == "Mining") then
				local skill = botdcore.GetProfessionLevel(botdcore.PlayerProfessionTwo)
				profTwoString = botdcore.PlayerProfessionTwo .. " - " ..skill

				
			end
			
			content2.professionOne.text:SetText(profOneString)
			content2.professionTwo.text:SetText(profTwoString)

			if (botdcore.PlayerProfessionThree ~= nil and botdcore.PlayerProfessionThree ~= "") then
				content2.professionThree.text:SetText(profThreeString)
			end
			if (botdcore.PlayerProfessionFour ~= nil and botdcore.PlayerProfessionFour ~= "") then
				content2.professionFour.text:SetText(profFourString)
			end
			if (botdcore.PlayerProfessionFive ~= nil and botdcore.PlayerProfessionFive ~= "") then
				content2.professionFive.text:SetText(profFiveString)
			end
		end


		if (botdcore.PlayerProfessionOne == botdcore.PlayerProfessionTwo) then
			botdcore.GetProfessions()
			
			profOneString = "Professions:\n" .. botdcore.PlayerProfessionOne .. " - " .. botdcore.PlayerProfessionOneLvl
			profTwoString = botdcore.PlayerProfessionTwo .. " - " .. botdcore.PlayerProfessionTwoLvl
			if (botdcore.PlayerProfessionOne == "Herbalism" or botdcore.PlayerProfessionOne == "Mining") then
				profOneString = botdcore.PlayerProfessionOne
			end
			if (botdcore.PlayerProfessionTwo == "Herbalism" or botdcore.PlayerProfessionTwo == "Mining") then
				profTwoString = botdcore.PlayerProfessionTwo
			end
			
			content2.professionOne.text:SetText(profOneString)
			content2.professionTwo.text:SetText(profTwoString)
		end
		botdcore.CheckBuff()
		inGuild = IsInGuild()
		if (inGuild) then
			if(IsInGroup())then
				raidbtnicon:Show()
			else
				raidbtnicon:Hide()
			end
			-- PROMOTE_LEADER = PromoteLeader
			botdcore.CreateOnlinePlayerList()
			pLeader = UnitLeadsAnyGroup("player")

			--Disband the party
			if (DisbanPartyButton ~= nil) then
				if (pLeader) then
					DisbanPartyButton:Show()
				else
					DisbanPartyButton:Hide()
				end
			end
			
			--If player is in party show leave button otherwise hide it.
			if (IsInGroup() == false and PlayerLeavePartyButton ~= nil) then
				PlayerLeavePartyButton:Hide()
			else
				if (PlayerLeavePartyButton ~= nil) then
					PlayerLeavePartyButton:Show()
				end
			end

			-- if (pLeader) then
			-- 	DisbanPartyButton:Show()
			-- else
			-- 	DisbanPartyButton:Hide()
			-- end
			if (PromoteLeader and whispered == ".$botd_jp_!" and invitePlayer ~= "" and IsInGroup() and pLeader) then
				PromoteToLeader(invitePlayer)
				if (PromoteLeader and IsInGroup() and pLeader == false) then
					whispered = ""
					invitePlayer = ""
					content4.promoteToLeader:SetChecked(false)
					PromoteLeader = false
				end
			end

			-- Changes guild GUI text for AFK/ME/PL and normal
			if (table.empty(vars) == false) then
				--itterate through the GuildOnlinePlayerList table
				for tmpindex, tmpplayer in ipairs(botdcore.GuildOnlinePlayerList) do
					character = tmpplayer.name
					charColor = GetClassColor(tmpplayer.class)

					isPl = UnitIsGroupLeader(character)
					heightUi = UIConfig:GetHeight()
					widthUi = UIConfig:GetWidth()
					content1:SetWidth(widthUi)
					content1:SetHeight(heightUi)
					vars[character]:SetWidth(widthUi)

					if(network ~= nil)then
						if heightUi <= 200 then
							network:Hide()
							network.text:Hide()
						else
							network:Show()
							network.text:Show()
						end
					end
					if(widthUi <= 235) then
						tab4:Hide()
					else
						tab4:Show()
					end

					if(widthUi <= 175) then
						tab3:Hide()
					else
						tab3:Show()
					end

					if(widthUi <= 125) then
						tab2:Hide()
					else
						tab2:Show()
					end
					
					-- check if afk
					if (tmpplayer.status == 1) then
						isPlTrue = false
						GuildMaster = ""
						if (tmpplayer.rank == "Guild Master") then
							GuildMaster = "|cFF0099ff[GM]|r "
						end
						if (UnitName("player") == character and pLeader) then
							vars[character].text:SetText(
								GuildMaster .. purple .. "<AFK>|r" .. red .. "[PL]|r" .. green .. character .. "[" .. tmpplayer.level .. "]|r"
							)
						elseif (isPl) then
							if (UnitName("player") ~= character and isPl) then
								vars[character].text:SetText(
									GuildMaster ..
										purple .. "<AFK>|r" .. red .. "[PL]|r" .. charColor .. character .. "[" .. tmpplayer.level .. "]|r"
								)
							end
						elseif (UnitName("player") == character) then
							-- elseif (SearchTableForValue(partyLeaders, character)) then
							-- 	vars[character].text:SetText(
							-- 		purple .. "<AFK>|r" .. red .. "[PL]|r" .. charColor .. character .. "[" .. tmpplayer.level .. "]|r"
							-- 	)
							vars[character].text:SetText(
								GuildMaster .. purple .. "<AFK>|r" .. green .. character .. "[" .. tmpplayer.level .. "]|r"
							)
						else
							vars[character].text:SetText(
								GuildMaster .. purple .. "<AFK>|r" .. charColor .. character .. "[" .. tmpplayer.level .. "]|r"
							)
						end
					else
						GuildMaster = ""
						if (tmpplayer.rank == "Guild Master") then
							GuildMaster = "|cFF0099ff[GM]|r "
						end
						if (UnitName("player") ~= character) then
							if (not isPl) then
									vars[character].text:SetText(GuildMaster .. charColor .. character .. "[" .. tmpplayer.level .. "]|r")
								else
									vars[character].text:SetText(
										GuildMaster .. red .. "[PL]|r" .. charColor .. character .. "[" .. tmpplayer.level .. "]|r"
									)
								end
						else
							vars[character].text:SetText(GuildMaster .. green .. character .. "[" .. tmpplayer.level .. "]|r")
						end
						if (pLeader) then
							if (UnitName("player") == character and pLeader) then
								vars[character].text:SetText(
									GuildMaster .. red .. "[PL]|r" .. green .. character .. "[" .. tmpplayer.level .. "]|r"
								)
							end
						elseif (isPl) then
							if (UnitName("player") ~= character and isPl) then
								vars[character].text:SetText(
									GuildMaster .. red .. "[PL]|r" .. charColor .. character .. "[" .. tmpplayer.level .. "]|r"
								)
							end
						else
							-- if (table.empty(partyLeaders) == false) then
							-- 	for indtwo, valtwo in ipairs(partyLeaders) do
							-- 		if (UnitName("player") ~= character) then
							-- 			if(valtwo == character) then
							-- 			vars[tmpplayer.name].text:SetText(
							-- 				red .. "[PL]|r" .. charColor .. tmpplayer.name .. "[" .. tmpplayer.level .. "]|r"
							-- 			)
							-- 			end
							-- 		end
							-- 	end
							-- end
						end
						for indthree, valthree in ipairs(afkList) do
							val = table.remove(afkList, indthree)
						end
					end
					-- ZoneMinLevel, ZoneMaxLevel = GetCurrentMapLevelRange()
					--Network:

					-- if PreviousZone ~= GetZoneText() then
					-- 	print(PreviousZone)
					-- 	print(GetZoneText())
					-- 	if MyZoneFrame ~= nil and MyZoneFrame.ZoneLevel ~= nil then
					-- 		MyZoneFrame:Hide()
					-- 		MyZoneFrame.ZoneLevel.text:Hide()
					-- 	end

					-- 	PreviousZone = GetZoneText()

					-- end
					if (UnitName("player") == character) then
						MyPlayer = tmpplayer
						ZoneTextandNetworkText(tmpplayer)
						bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
						if (bandwidthIn ~= nil and bandwidthOut ~= nil)  then
							network.text:SetText(
								"World Latency: " ..
									latencyWorld ..
										"\nHome Latency: " .. latencyHome .. "\nBandwidth In: " .. botdcore.roundDec(bandwidthIn, 1)
										.. "\nBandwidth Out: " .. botdcore.roundDec(bandwidthOut, 1)
							)
						end
						--Rest State
						exhaustionXP = GetXPExhaustion()
						currXP = UnitXP("player")
						xptolevel = UnitXPMax("player")
						currReststate, restname, restmultiplier = GetRestState()
						if (exhaustionXP ~= nil and restname == "Rested") then
							xptobarratio = xptolevel / 20
							totalrestedbars = exhaustionXP / xptobarratio
							barstoding = (xptolevel-currXP) / xptobarratio
							--Need to find the bar to experience ratio
							RestState.text:SetText(white..restname)
							if (totalrestedbars ~= nil) then
							RestStateBars.text:SetText(blue.."Bars: |r"..white..botdcore.roundDec(totalrestedbars, 1))
							end
							-- RestStateBars.text:SetText(blue.."\nBars Rested: |r"..white..botdcore.roundDec(totalrestedbars, 1))
							-- RestStateBarsToDing.text:SetText(blue.."\nBars to Ding: |r"..white..botdcore.roundDec(barstoding))
						else
							RestState.text:SetText(white.."Normal")
							RestStateBars.text:SetText(blue.."Bars: |r"..white.."0")
						end
						if(barstoding ~= nil) then
							RestStateBarsToDing.text:SetText(blue.."To Ding: |r"..white..botdcore.roundDec(barstoding, 1))
						end
						-- blue.."\nRested for: |r"..white..botdcore.comma_value(exhaustionXP).."xp"..
						-- blue.."\nExperience multiplier: |r" .. white..restmultiplier .. "x/per kill"..
						-- blue.."\nXP Gained: |r"..white..botdcore.comma_value(currXP).."xp"..
						-- blue.."\nTotal Experience: |r"..white..botdcore.comma_value(xptolevel).."xp"

					-- if (UIConfig:IsVisible() or UIConfig:IsShown()) then
					-- 	if (table.empty(zoneTbl) ~= false) then
					-- 		zoneTbl[tmpplayer.zone]:Show()
					-- 	end
					-- else
					-- 	if (table.empty(zoneTbl) ~= false) then
					-- 		zoneTbl[tmpplayer.zone]:Hide()
					-- 	end
					-- end

					-- Returns the name of the frame under the mouse, if it's named
					end
					-- cursorX1, cursorY1 = GetCursorPosition()
					-- print(cursorX1)
					-- Show tooltip when hover over players on the addon
					local frame = GetMouseFocus()
					if not frame or frame == nil then
						-- ChatFrame1:AddMessage("There is no mouse enabled frame under the cursor")
					else
						local name = frame:GetName() or tostring(frame)
						if (name == tmpplayer.name) then
							buffList = CheckBuffListTable(tmpplayer.name)
							buffs = ""
							for indthree, valthree in ipairs(buffList) do
								if buffs == "" then
									buffs = "Buffs: " .. valthree
								else
									buffs = buffs .. ", " .. valthree
								end
							end
							GMaster = ""
							if (tmpplayer.rank == "Guild Master") then
								GMaster = "|cFF0099ff[GRAMPS]:|r "
							end
							cursorX, cursorY = GetCursorPosition()
							onTaxi = UnitOnTaxi(tmpplayer.name)
							hoverMessage = ""
							-- if (onTaxi) then
							if (tmpplayer.status == 1) then
								hoverMessage =
									GMaster ..
									purple ..
										"<AFK>|r" ..
											charColor ..
												character .. "[" .. tmpplayer.level .. " : " .. tmpplayer.class .. "] " .. tmpplayer.zone .. "\n" .. buffs
								PlayerInfoOnHoverFrame.text:SetText(hoverMessage)
							else
								hoverMessage =
									GMaster ..
									charColor ..
										character .. "[" .. tmpplayer.level .. " : " .. tmpplayer.class .. "] " .. tmpplayer.zone .. 
										"\n" .. buffs

								PlayerInfoOnHoverFrame.text:SetText(hoverMessage)
							end

							-- PlayerInfoOnHoverFrame:SetPoint("BOTTOMLEFT", -245, cursorY - 130)
							if (#hoverMessage > 100 and #hoverMessage < 470) then
								PlayerInfoOnHoverFrame:SetHeight(140)
								PlayerInfoOnHoverFrame:SetWidth(400)
								if(cursorX < 350) then
									PlayerInfoOnHoverFrame:SetPoint("CENTER", 313, 0)
								-- elseif(cursorX > 330 and cursorX < 540) then
								-- 	PlayerInfoOnHoverFrame:SetPoint("BOTTOMLEFT", cursorX - 400, cursorY - 50)
								else
									PlayerInfoOnHoverFrame:SetPoint("CENTER", -312, 0)
								end
							elseif (#hoverMessage > 470) then
								PlayerInfoOnHoverFrame:SetHeight(250)
								PlayerInfoOnHoverFrame:SetWidth(600)
								if(cursorX < 580) then
									PlayerInfoOnHoverFrame:SetPoint("CENTER", 413, 0)
								-- elseif(cursorX > 330 and cursorX < 540) then
								-- 	PlayerInfoOnHoverFrame:SetPoint("BOTTOMLEFT", cursorX - 600, cursorY - 50)
								else
									PlayerInfoOnHoverFrame:SetPoint("CENTER", -412, 0)
								end
							else
								if(cursorX < 340) then
									-- PlayerInfoOnHoverFrame:SetPoint("BOTTOMLEFT", cursorX + 35, cursorY - 10)
								-- elseif(cursorX > 330 and cursorX < 540) then
								-- 	PlayerInfoOnHoverFrame:SetPoint("BOTTOMLEFT", cursorX - 370, cursorY - 50)
									PlayerInfoOnHoverFrame:SetPoint("CENTER", 300, 0)
								else
								-- 	PlayerInfoOnHoverFrame:SetPoint("BOTTOMLEFT", cursorX - 320, cursorY - 10)
									PlayerInfoOnHoverFrame:SetPoint("CENTER", -300, 0)
								end

							end
							PlayerInfoOnHoverFrame:Show()
						else
							if (not SearchTableForPlayerName(botdcore.GuildOnlinePlayerList, name)) then
								PlayerInfoOnHoverFrame:Hide()
							end
						end
					end

					if ShowDungeonMp == true then
						ShowDunMap(GetZoneText())
						MapFrame.title:SetText(GetZoneText())

						ShowDungeonMap:SetText("Hide Map")
						MyInstanceKeyFrame:Show()
						MyInstanceKeyFrame.InstanceKey.text:SetText(InstanceKey[GetZoneText()])
						MyInstanceKeyFrame.InstanceKey.text:Show()
						-- content2.DungeonButtonText:Show()
						-- content2.DungeonButtonText.text:Show()
					else
						MapFrame:Hide()
						ShowDungeonMp = false
						mapTexture:Hide()
						ShowDungeonMap:SetText("Show Map")
						MyInstanceKeyFrame:Hide()
						MyInstanceKeyFrame.InstanceKey.text:Hide()
						-- content2.DungeonButtonText:Hide()
						-- content2.DungeonButtonText.text:Hide()
					end

					--[[
					-- 	Show/Hide Follow button
					-- ]]
					if (table.empty(varsFollowBtns) == false) then
						canInteract = CheckInteractDistance(tmpplayer.name, 4)
						if (canInteract == true and tmpplayer.name ~= UnitName("player")) then
							varsFollowBtns[tmpplayer.name]:Show()
						elseif (canInteract == false and tmpplayer.name ~= UnitName("player")) then
							varsFollowBtns[tmpplayer.name]:Hide()
						end
					end

					--If Not in a group and not playername hide follow button
					if (IsInGroup() == false and tmpplayer.name ~= UnitName("player")) then
						varsFollowBtns[tmpplayer.name]:Hide()
					end

					--[[
					-- 	Show/Hide Group button
					-- ]]
					if (table.empty(varsGroupBtns) == false and IsInGroup() and tmpplayer.name ~= UnitName("player")) then
						local uLeads = UnitLeadsAnyGroup("player")

						-- If in a group and not party leader hide group buttons

						--If in a group and you are the party leader hide group buttons for people in your group,
						--but show goup buttons for people who aren't in your group
						local names = GetHomePartyInfo()
						inParty = SearchTableForValue(names, tmpplayer.name)
						-- print(tmpplayer.name)
						-- for tmpindex, tmpplayer in ipairs(names) do

						-- end
						-- if names then print("in home party")
						-- 	print(x1[1], x1[2], x1[3], x1[4])
						-- else print("nope")
						-- end
						if (inParty) then
							varsGroupBtns[tmpplayer.name]:Hide()
						else
							varsGroupBtns[tmpplayer.name]:Show()
						end
						if (not uLeads) then
							varsGroupBtns[tmpplayer.name]:Hide()
						end
					
					end
					--If not in a group show group buttons
					if (table.empty(varsGroupBtns) == false and not IsInGroup() and tmpplayer.name ~= UnitName("player")) then
						varsGroupBtns[tmpplayer.name]:Show()
					end

					
					-- canInteract = CheckInteractDistance(tmpplayer.name, 4)
					-- print(canInteract)

					-- if (canInteract and tmpplayer.name ~= UnitName("player")) then
					-- 	varsFollowBtns[tmpplayer.name]:Show()
					-- elseif (canInteract == false and tmpplayer.name ~= UnitName("player")) then
					-- 	varsFollowBtns[tmpplayer.name]:Hide()
					-- end
				end
			end
			--------------> Show/Hide scrollbar
			if (GetTableCount(botdcore.GuildOnlinePlayerList) < 9) then
				botdcore.scrollbar:Hide()
			else
				botdcore.scrollbar:Show()
			end

		--Check if buff is expired or expiring
		-- botdcore.CheckBuff()
		end
		if (TrackProfessions) then
			-- content2.text:Show()
		else
			-- content2.text:Hide()
		end
		total = 0
	end

	--Display Currently Equipped Item Level
	currentItemLevel = botdcore.GetItemLevel()
	if (currentItemLevel ~= firstItemLevel) then
		firstItemLevel = currentItemLevel
		content1.ilevel.text:SetText("")
		content1.ilevel.text:SetText("iLevel: " .. charColor .. currentItemLevel .. "|r")
	end
	
	--Delayed Update
	if totalLonger >= RefreshFriendsLonger then
		inGuild = IsInGuild()
		if (inGuild) then
		end
		totalLonger = 0
	end
end

local AcquireFrame, ReleaseFrame
do
	local frame_cache = {}

	function AcquireFrame(parent)
		local frame = tremove(frame_cache) or CreateFrame("Frame")
		frame:SetParent(parent)
		return frame
	end

	function ReleaseFrame(frame)
		frame:Hide()
		frame:SetParent(nil)
		frame:ClearAllPoints()
		tinsert(frame_cache, frame)
	end
end -- do block

--[[
	Show current instance quest location and drops
]]
--Welcome and Events
---->>>>>>>

-- function CreateInstanceKeyTable()
-- 	table.insert(botdcore.instances, "Blackfathom Deeps")
--     table.insert(botdcore.instances, "Uldaman")
--     table.insert(botdcore.instances, "Wailing Caverns")
--     table.insert(botdcore.instances, "The Deadmines")
--     table.insert(botdcore.instances, "Scarlet Monastery")
--     table.insert(botdcore.instances, "Shadowfang Keep")
--     table.insert(botdcore.instances, "Scholomance")
--     table.insert(botdcore.instances, "Stratholme (Main Gate)")
--     table.insert(botdcore.instances, "Stratholme (Service Gate)")
--     table.insert(botdcore.instances, "Gnomeregan")
--     table.insert(botdcore.instances, "Temple of Atal'Hakkar")
--     table.insert(botdcore.instances, "The Stockade")
--     table.insert(botdcore.instances, "Razorfen Kraul")
--     table.insert(botdcore.instances, "Razorfen Downs")
--     table.insert(botdcore.instances, "Maraudon")
--     table.insert(botdcore.instances, "Dire Maul")
--     table.insert(botdcore.instances, "Zul'Farrak")
--     table.insert(botdcore.instances, "Ragefire Chasm")

-- end
function testcode()
print("TESTING")
end
function BoTD_OnEvent_OnLoad(self)
	self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	self:RegisterEvent("BAG_NEW_ITEMS_UPDATED");
	self:RegisterEvent("BAG_SLOT_FLAGS_UPDATED");
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("ITEM_PUSH");
	self:RegisterEvent("CURSOR_UPDATE");
	self:RegisterEvent("UPDATE_INVENTORY_ALERTS");
	self:RegisterEvent("CHAT_MSG_LOOT");
	-- self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

	
end



local f = CreateFrame("Frame")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:SetScript("OnEvent", function(self, event)
	-- pass a variable number of arguments
	self:OnEvent(event, CombatLogGetCurrentEventInfo())
end)

function f:OnEvent(event, ...)
	local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
	if (subevent == "UNIT_DIED" and botdcore.alertKillCount) then
		if(IsInGroup() and botdcore.alertKillCount)then
			botdcore.alertKillCount = false
			-- botdcore.QuestPartyMonsterKillCountAlert(UnitName("player"), destName)
		end
	end

end


local totalcount = 0

local function onUpdate(self,elapsed)
    totalcount = totalcount + elapsed
    if totalcount >= 0.20 then
        botdcore.alertKillCount = true
        totalcount = 0
    end
end

local f = CreateFrame("frame")
f:SetScript("OnUpdate", onUpdate)
-- local function filter(self,event,message,sender,...)
-- 	local text = message:match("(.+ )\124c.-\124h\124r.+")
-- 	if text then
-- 	  message = message:gsub(text,"+ ")
-- 	end
-- 	return false, message, sender, ...
--   end
--   ChatFrame_AddMessageEventFilter("CHAT_MSG_LOOT",filter)


function InitAddon()
	local InfoAddonPlayerInfoFrame, events = CreateFrame("FRAME"), {}
	
	local redcolour, defaultcolour = "|cFFFF0000", "|r"
	-- local functions
	function BoTDOfficialWelcome()
		-- Print out Addon Information.
		print(
			"|cffFF8C00 [BoTD] -----------------------------|cff8A2BE2[Beta v0.3.2.6]|r|cffFF8C00------------------------------- |r"
		)
		print("|cffFF8C00 [BoTD]|r |cff8A2BE2Thank you for using the BoTD Addon, |cffFFFFFF" .. UnitName("player") .. "!|r")
		print("|cFFA9A9A9 [|r|cffFF8C00BoTD|r|cFFA9A9A9] BoTD Addon has successfully loaded! |r")
		print("|cffFF8C00 [BoTD] |r|cFFA9A9A9Hello, Welcome to the BoTD Addon|r")
		print(
			"|cffFF8C00 [BoTD] ----------------------------|r|cff8A2BE2[Good Hunting!]|r|cffFF8C00------------------------------ |r"
		)
		print("   ")
	end
	-- Event handlers
	function events:ZONE_CHANGED_NEW_AREA(...)
		-- UIConfig:SetParent(nil)
		-- UIConfig:ClearAllPoints()
		-- CreateGUI()
		-- numFrames = GetNumFrames()
		-- print(numFrames)
	end
	
	-- function events:BAG_NEW_ITEMS_UPDATED(...) -- Only triggered when you have 0 of an item you are picking up...
	-- 	print("Picked up a new item!")
	-- 	party = GetHomePartyInfo()
	-- 	if(IsInGroup())then
	-- 		for partyIndex,partyPlayerName in ipairs(party) do
	-- 			botdcore.QuestPartyDropCountAlert(partyPlayerName)
	-- 		end
	-- 	else
	-- 		botdcore.QuestDropCountAlert()
	-- 	end
	-- end

	function events:BAG_UPDATE(...)
		
	end
	
	function events:PLAYER_ENTERING_WORLD(...)
		-- UIConfig:SetBackdrop(StaticPopup1:GetBackdrop())
		UIConfig:ClearAllPoints()
		-- UIConfig:SetSize(235, 220) -- width, height

		macroName, macroTexture, macroBody = GetMacroInfo("BoTD Menu")
		if (macroName ~= "BoTD Menu") then
			local macro = CreateMacro("BoTD Menu", 136232, "/menu", 1)
			PickupMacro("BoTD Menu")
		end
		

		-- if PROMOTE_LEADER == nil then
		-- 	PROMOTE_LEADER = true
		-- end
		-- if PROMOTE_LEADER then
		-- 	print("Promote Leader Enabled for , " .. UnitName("player") .. "!")
		-- end
		-- BoTDOfficialWelcome()
		-- botdcore.CreateGUI()
		-- print("New Zone")

		-- LeaveParty()
		-- botdcore.CreateGuildList()
		
	end

	function events:GROUP_LEFT(...)
		local uLeads = UnitLeadsAnyGroup("player")

		for i = 1, GetNumGuildMembers() do
			playerInList = false
			fullName,
				rank,
				rankIndex,
				level,
				class,
				zone,
				note,
				officernote,
				online,
				status,
				classFileName,
				achievementPoints,
				achievementRank,
				isMobile,
				canSoR,
				reputation = GetGuildRosterInfo(i)
			charName, realm = strsplit("-", fullName)
			inparty = UnitInParty(charName)
			if (online and inparty == false and UnitName("player") ~= charName) then
			-- SendChatMessage(".$botd_notptyLd_!", "WHISPER", nil, charName)
			end
		end
		PromoteLeader = PROMOTE_LEADER
		content4.promoteToLeader:SetChecked(PROMOTE_LEADER)
		
	end
	function events:ADDON_LOADED(...)

		PromoteLeader = PROMOTE_LEADER
		ManaWarning = ANNOUNCEMANAWARNING
		AllowFollow = ALLOWFOLLOWVAR
	end
	function events:PLAYER_LOGOUT(...)
		PROMOTE_LEADER = PromoteLeader
		ANNOUNCEMANAWARNING = ManaWarning
		ALLOWFOLLOWVAR = AllowFollow
	end

	function events:FRIENDLIST_UPDATE(...)
		
	end
	function events:GROUP_ROSTER_UPDATE(...)
		pLeader = UnitLeadsAnyGroup("player")

		-- if PromoteLeader and LostPartyLeader == false then
		-- 	-- PromoteToLeader(invitePlayer)

		-- 	for i1, v1 in ipairs(partyLeaders) do
		-- 		print("NAME IS: " .. v1)
		-- 		if (v1 == UnitName("player")) then
		-- 			table.remove(partyLeaders, i1)
		-- 		end
		-- 	end
		-- end
	end

	for k, v in pairs(events) do
		InfoAddonPlayerInfoFrame:RegisterEvent(k)
	end

	-- -- Set Script
	InfoAddonPlayerInfoFrame:SetScript(
		"OnEvent",
		function(self, event, ...)
			events[event](self, ...)
		end
	)

end
argument1, argument2 = nil
local function err (x)
	print (orange.."BoTD"..purple..version..red..": Error occured - ", x)
	return x
  end

function BoTD_OnEvent(self, event, ...)
	local arg1, arg2 = ...;
	argument1 = arg1
	argument2 = arg2

	-- if ( event == "PLAYER_EQUIPMENT_CHANGED" ) then
	-- 	if ( self:GetID() == arg1 ) then
	-- 		PaperDollItemSlotButton_Update(self);
	-- 	end
	
	if ( event == "UNIT_INVENTORY_CHANGED" ) then
		-- print("INVENTORY CHANGED:")
		-- party = GetHomePartyInfo()
		-- if(IsInGroup())then
		-- 	for partyIndex,partyPlayerName in ipairs(party) do
		-- 		botdcore.QuestPartyDropCountAlert(partyPlayerName, arg1)
		-- 	end
		-- else
		-- 	-- status, err, ret = xpcall(botdcore.QuestDropCountAlert, err, UnitName("player"), arg1)
		-- 	print(arg1)

		-- 	botdcore.QuestDropCountAlert(UnitName("player"), arg1)
		-- end
	elseif(event == "CHAT_MSG_LOOT") then
		local lootstring, _, _, _, player = ...
		local you = string.match(lootstring, 'You')
		if you ~= "" and you ~= nil then
			local itemLink = string.match(lootstring,"|%x+|Hitem:.-|h.-|h|r")
			local itemString = string.match(itemLink, "item[%-?%d:]+")
			name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemString)

			party = GetHomePartyInfo()
			if(IsInGroup())then
				botdcore.QuestPartyDropCountAlert(UnitName("player"), name)
			end
				--USE THIS:
				-- for partyIndex,partyPlayerName in ipairs(party) do
				-- 	botdcore.QuestPartyDropCountAlert(partyPlayerName, name)
				-- end
			-- end
		end
	elseif ( event == "BAG_NEW_ITEMS_UPDATED" ) then
	-- elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		
	-- 	matchthis = UnitName("player").." has slain"

	-- 	local combatEvent = select(2, ...)
	-- 	print(combatEvent)
	-- 	if combatEvent == "UNIT_DIED" then
	-- 	   local sourceName = select(4, ...)
	-- 	   local destGUID = select(6, ...)
	-- 	   print(sourceName)
	-- 	--    if isShoveltusk (destGUID) then
	-- 	-- 	  print(sourceName .. " has killed a Shoveltusk Stag!")
	-- 	--    end
	-- 	end

	-- 	local killstring, _, _, _, player = ...
	-- 	if(killstring ~= nil) then
	-- 		local slain = string.match(lootstring, killstring)
	-- 	-- if(IsInGroup())then
	-- 		print(slain)
	-- 	end
			-- botdcore.QuestPartyDropCountAlert(UnitName("player"), name)
		-- end
	elseif ( event == "BAG_SLOT_FLAGS_UPDATED" ) then
		
	elseif ( event == "BAG_UPDATE" ) then
		
	elseif ( event == "ITEM_PUSH" ) then
		
	end
end


--name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(itemID) or GetItemInfo("itemName")
--Print in the tooltip the iLevel of the item the cursor is hovering over
function CreateGUI()
	botdcore.CreateMenu()
	botdcore.SetupZoning()
	botdcore.SetupInstanceKey()
	PlayerInfoOnHover()
	botdcore.GetProfessions()
	if (botdcore.PlayerProfessionOne == "Mining" or botdcore.PlayerProfessionTwo == "Mining") then
		botdcore.ShowMiningLocations()
	end	
end
-- InitAddon()
-- BoTDOfficialWelcome()
-- CreateGUI()
local f = CreateFrame("frame")
f:SetScript("OnUpdate", OnUpdate)
-- /w loonn .botd_jp

-- local frame = CreateFrame("FRAME") -- Need a frame to respond to events
-- frame:RegisterEvent("ADDON_LOADED") -- Fired when saved variables are loaded
-- frame:RegisterEvent("PLAYER_LOGOUT") -- Fired when about to log out
-- function frame:OnEvent(event, arg1)
	
-- 	if event == "ADDON_LOADED" and arg1 == "BoTD" then
-- 		PromoteLeader = PROMOTE_LEADER
-- 		ManaWarning = ANNOUNCEMANAWARNING
-- 		AllowFollow = ALLOWFOLLOWVAR

-- 		-- if PROMOTE_LEADER == nil then
-- 		-- 	PROMOTE_LEADER = true
-- 		-- end
-- 		if PROMOTE_LEADER then
-- 			print("Promote Leader Enabled for , " .. UnitName("player") .. "!")
-- 		end
-- 	elseif event == "PLAYER_LOGOUT" then
-- 		PROMOTE_LEADER = PromoteLeader
-- 		ANNOUNCEMANAWARNING = ManaWarning
-- 		ALLOWFOLLOWVAR = AllowFollow


-- 	-- LeaveParty()
	
-- 	end
-- end
