--[[
	## BoTD Group WoW Classic Addon 
	## 10/9/2019
	## Brandon Autry
	## brandon@bitdraft.com
	## Vers: [Beta v0.3.2.6]
	## BoTDHelper.lua 
	]]
--------------------------------------
-- Namespaces
--------------------------------------

-- local _, botdcore = ... -- Namespace

-- For colors just add cFF in front of the #FF8C00 <- Hex DarkOrange
-- Addon logging information when character enters world.

local addonName, botdcore = ...
bufflist = {}
alreadyAnnounceList = {}

function table.empty(self)
	for _, _ in pairs(self) do
		return false
	end
	return true
end

SkillsToAnnounce = {
	"Fear Ward",
	"Shadow Protection",
	"Divine Spirit",
	"Mark of the Wild",
	"Thorns",
	"Righteous Fury",
	"Blessing of Kings",
	"Greater Blessing of Kings",
	"Blessing of Wisdom",
	"Greater Blessing of Wisdom",
	"Blessing of Might",
	"Greater Blessing of Might",
	"Blessing of Sanctuary",
	"Greater Blessing of Sanctuary",
	"Blessing of Salvation",
	"Greater Blessing of Salvation",
	"Prayer of Fortitude",
	"Prayer of Shadow Protection",
	"Prayer of Spirit",
	"Gift of the Wild",
	"Dampen Magic",
	"Amplify Magic",
	"Arcane Brilliance",
	"Arcane Intellect",
	"Soulstone Resurrection",
	"Detect Lesser Invisibility",
	"Power Word: Fortitude"
}



SkillsToIgnore = {"Renew","Power Word: Shield","Honorless Target", "Blessing of Freedom", "Blessing of Protection", 
"Divine Protection", "Stealth", "Cat Form", "Bear Form", "Aquatic Form", "Rejuvenation", "Regrowth"}
buffCount = 0
xOffSet, yOffSet = 10
AnounceIndex = 0
announced = false
-- Text colors
orange = "|cffFF8C00"
darkgrey = "|cffA9A9A9"
purple = "|cff8A2BE2"
white = "|cFFFFFFFF"
red = "|cFFFF0000"
green = "|cFF4ddb00"

botdVersion = purple .. "[BoTD] " .. version .. "|r "

-- Strings
-- version = "[0.3.2.6]" --Version Number

-- Create a general macro

function starts_with(str, start)
	return str:sub(1, #start) == start
end
-- loop and find out the timeLeft and create list
-- anounce once and icon to gui once

local function CreateCurrentBuffList()
	for i = 1, 40 do
		buffInList = false
		name,
			rank,
			icon,
			count,
			dispelType,
			duration,
			expires,
			caster,
			isStealable,
			nameplateShowPersonal,
			spellID,
			canApplyAura,
			isBossDebuff,
			_,
			nameplateShowAll,
			timeMod,
			value1,
			value2,
			value3 = UnitBuff("player", i)
		if name then
			for inde, valu in ipairs(bufflist) do
				if (valu == name) then
					buffInList = true
				end
			end
			if (buffInList == true) then
			else
				table.insert(bufflist, name)
				buffInList = false
				buffCount = buffCount + 1
			end
		end
	end
end


-- MOD_TextFrameTime = 0;
SubBuffTextFrameTime = 0
function botdcore.SubBuffTextFrame_OnUpdate()
  if (SubBuffTextFrameTime < GetTime() - 5) then
    local alpha = SubBuffTextFrame:GetAlpha();
    if (alpha ~= 0) then SubBuffTextFrame:SetAlpha(alpha - .05); end
    if (alpha == 0) then SubBuffTextFrame:Hide(); end
  end
end

function botdcore.SubBuffTextMessage(message)
	SubBuffTextFrame.text:SetText(message);
	SubBuffTextFrame:SetAlpha(1);
	SubBuffTextFrame:Show();
	SubBuffTextFrameTime = GetTime();
end




local function SearchTableForValue(chTable, buffName)
	for checkInd, checkVal in ipairs(chTable) do
		if (buffName == checkVal) then
			return true
		else
		end
	end
	return false
end
local function CheckBuffListTable()
	tempBuffList = {}

	for i = 1, 40 do
		buffInList = false
		name,
			rank,
			icon,
			count,
			dispelType,
			duration,
			expires,
			caster,
			isStealable,
			nameplateShowPersonal,
			spellID,
			canApplyAura,
			isBossDebuff,
			_,
			nameplateShowAll,
			timeMod,
			value1,
			value2,
			value3 = UnitBuff("player", i)
		if name then
			for inde, valu in ipairs(tempBuffList) do
				if (valu == name) then
					buffInList = true
				end
			end
			if (buffInList == true) then
			else
				table.insert(tempBuffList, name)
				buffInList = false
			end
		end
	end

	for i, v in ipairs(bufflist) do
		buffInList1 = false
		for i1, v1 in ipairs(tempBuffList) do
			if (v == v1) then
				buffInList1 = true
			end
		end
		if (buffInList1 == true) then
		else
			val = table.remove(bufflist, i)
			-- if (SearchTableForValue(CHARSKILLSTOANNOUNCE, v) or SearchTableForValue(SkillsToAnnounce, v)) then
			if (CHARSKILLSTOANNOUNCE ~= nil) then
				if (SearchTableForValue(CHARSKILLSTOANNOUNCE, v)) then
					botdcore.SubBuffTextMessage(purple .. "[BoTD] " .. version .. "|r " .. red .. v .. " has expired.|r")
					PlaySoundFile("Interface\\Addons\\BoTD\\sounds\\expired.mp3")
					print(orange .. "[BoTD] " .. version .. "|r " .. purple .. v .. " has expired.|r")
				end
			elseif (CHARSKILLSTOANNOUNCE == nil and not SearchTableForValue(SkillsToAnnounce, v)) then

			-- elseif (CHARSKILLSTOANNOUNCE == nil and not SearchTableForValue(SkillsToAnnounce, v) and not SearchTableForValue(SkillsToIgnore, v)) then
			-- 	message(orange .. "[BoTD] " .. version .. "|r " .. purple .. " Please check your chat log for instructions.|r")
			-- 	print(
			-- 		red ..
			-- 			"[BoTD] " ..
			-- 				version ..
			-- 					"|r " ..
			-- 						white ..
			-- 							" Please add buffs/skills to the BoTD.lua file located:WoW/_classic/WTF/ACCOUNT/ACCOUNTNAME/"..GetRealmName().."/" ..
			-- 								UnitName("player") .. "/SavedVariables/BoTD.lua|r"
			-- 	)
			end
			if (SearchTableForValue(SkillsToAnnounce, v)) then
				print(orange .. "[BoTD] " .. version .. "|r " .. purple .. v .. " has expired.|r")
			end
			for ind, valu in ipairs(alreadyAnnounceList) do
				if (v == valu) then
					rem = table.remove(alreadyAnnounceList, ind)
				end
			end
			buffInList1 = false
		end
	end
end

function tablelength(T)
	local count = 0
	for _ in pairs(T) do
		count = count + 1
	end
	return count
end

local function BuffAnnounce()
	for i = 1, 40 do
		name,
			rank,
			icon,
			count,
			dispelType,
			duration,
			expires,
			caster,
			isStealable,
			nameplateShowPersonal,
			spellID,
			canApplyAura,
			isBossDebuff,
			_,
			nameplateShowAll,
			timeMod,
			value1,
			value2,
			value3 = UnitAura("player", i)
		if name then
			timeLeft = false
			timeLeft = (math.ceil((duration - GetTime()) / 60))
			if (timeLeft <= 1) then
				check = SearchTableForValue(alreadyAnnounceList, name)
				if (check == false and SearchTableForValue(SkillsToAnnounce, name)) then
					msg = "[BoTD] " .. version .. ": ".. UnitName("player").."'s " .. name .. " has less than " .. timeLeft .. " minute left."
					if (UnitExists("party1")) then
						SendChatMessage(msg, "PARTY", nil, UnitName("player"))
					else
						msgOne = UnitName("player").."'s " .. name .. " has less than " .. timeLeft .. " minute left."
						print(orange .. "[BoTD] " .. version .. "|r " .. red .. msgOne .. "|r")
					end
					table.insert(alreadyAnnounceList, name)
				end
			end
		end
	end
end

function botdcore.CheckBuff()
	if (BuffTimerAnnounc) then
		CreateCurrentBuffList()
		CheckBuffListTable()
		BuffAnnounce()
	end
end

didannouncemanalevels = false

--Mana levels
function botdcore.CheckManaLevel()
	if (ANNOUNCEMANAWARNING) then
		power = UnitPower("player", 0)
		maxMana = UnitPowerMax("player", 0)
		getTwentyPercent = botdcore.Round((maxMana * 20) / 100)
		getSeventyFivePercent = botdcore.Round((maxMana * 75) / 100)

		if(power >= getSeventyFivePercent) then
			didannouncemanalevels = false
		end
		if power < getTwentyPercent then
			if (UnitExists("party1") and didannouncemanalevels == false) then
				msg = "[BoTD] " .. version .. ": I have less than 20% mana."
				SendChatMessage(msg, "PARTY", nil, UnitName("player"))
				didannouncemanalevels = true
			-- elseif(didannouncemanalevels == false) then
			-- 	msg = "[BoTD] " .. version .. ": I have less than 20% mana."
			-- 	SendChatMessage(msg, "YELL", nil, UnitName("player"))
			-- 	didannouncemanalevels = true
			end
		end
	end
end