--[[
	## BoTD Group WoW Classic Addon 
	## 10/9/2019
	## Brandon Autry
	## brandon@bitdraft.com
	## Vers: [Beta v0.3.2.6]
	## BoTDCore.lua 
	 ]] --

--------------------------------------
-- Namespaces
--------------------------------------
local addonName, botdcore = ...

-- Text colors
orange = "|cffFF8C00"
darkgrey = "|cffA9A9A9"
purple = "|cff8A2BE2"
white = "|cFFFFFFFF"
red = "|cFFFF0000"
green = "|cFF4ddb00"
grey = "|cFFA9A9A9"
-- Strings
version = "[0.3.2.6]" --Version Number

zoneMinMax = {}
zoneMiningMinMax = {}
InstanceKey = {}
botdcore.instances = {}

function botdcore.SetupZoning()
    -- Eastern Kingdoms
    zoneMinMax["Alterac Mountains"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 30-40|r" .. grey .. " [F:130+]|r"
    zoneMinMax["Arathi Highlands"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 30-40|r" .. grey .. " [F:130+]|r"
    zoneMinMax["Badlands"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 35-45"
    zoneMinMax["Blasted Lands"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 45-55"
    zoneMinMax["Burning Steppes"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 50-58|r" .. grey .. " [F:330+]|r"
    zoneMinMax["Deadwind Pass"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 55-60|r" .. grey .. " [F:330+]|r"
    zoneMinMax["Dun Morogh"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 1-10|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Duskwood"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 18-30|r" .. grey .. " [F:55+]|r"
    zoneMinMax["Eastern Plaguelands"] = "5:3-60|r" .. grey .. " [F:330+]|r"
    zoneMinMax["Elwynn Forest"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 1-10|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Hillsbrad Foothills"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 20-30|r" .. grey .. " [F:55+]|r"
    zoneMinMax["Ironforge"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " |r" .. grey .. " [F:1+]|r"
    zoneMinMax["Loch Modan"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 10-20|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Redridge Mountains"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 15-25|r" .. grey .. " [F:55+]|r"
    zoneMinMax["Searing Gorge"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 43-50"
    zoneMinMax["Silverpine Forest"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 10-20|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Stormwind City"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " |r" .. grey .. " [F:1+]|r"
    zoneMinMax["Stranglethorn Vale"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 30-45|r" .. grey .. " [F:130+]|r"
    zoneMinMax["Swamp of Sorrows"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 35-45|r" .. grey .. " [F:130+]|r"
    zoneMinMax["The Hinterlands"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 40-50|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Tirisfal Glades"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 1-10|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Undercity"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " |r" .. grey .. " [F:1+]|r"
    zoneMinMax["Westfall"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 10-20|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Western Plaguelands"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 51-58|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Wetlands"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 20-30|r" .. grey .. " [F:55+]|r"

    -- Kalimdor
    zoneMinMax["Ashenvale"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 18-30|r" .. grey .. " [F:55+]|r"
    zoneMinMax["Azshara"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 45-55|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Darkshore"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 10-20|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Darnassus"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " |r" .. grey .. " [F:1+]|r"
    zoneMinMax["Desolace"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 30-40|r" .. grey .. " [F:130+]|r"
    zoneMinMax["Durotar"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 1-10|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Dustwallow Marsh"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 35-45|r" .. grey .. " [F:130+]|r"
    zoneMinMax["Felwood"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 48-55|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Feralas"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 40-50|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Moonglade"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 1|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Mulgore"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 1-10|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Orgrimmar"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " |r" .. grey .. " [F:1+]|r"
    zoneMinMax["Silithus"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 55-60|r" .. grey .. " [F:330+]|r"
    zoneMinMax["Stonetalon Mountains"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 15-27|r" .. grey .. " [F:55+]|r"
    zoneMinMax["Tanaris"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 40-50|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Teldrassil"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 1-10|r" .. grey .. " [F:1+]|r"
    zoneMinMax["The Barrens"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 10-25|r" .. grey .. " [F:1+]|r"
    zoneMinMax["Thousand Needles"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 25-35|r" .. grey .. " [F:130+]|r"
    zoneMinMax["Thunder Bluff	"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " |r" .. grey .. " [F:1+]|r"
    zoneMinMax["Un'Goro Crater"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 48-55|r" .. grey .. " [F:205+]|r"
    zoneMinMax["Winterspring"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 55-60|r" .. grey .. " [F:330+]|r"

    --Dungeons
    zoneMinMax["Blackfathom Deeps"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 24-32"
    zoneMinMax["Uldaman"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 41-51"
    zoneMinMax["Wailing Caverns"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 17-24"
    zoneMinMax["The Deadmines"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 17-26"
    zoneMinMax["Scarlet Monastery"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 34-45"
    zoneMinMax["Shadowfang Keep"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 22-30"
    zoneMinMax["Scholomance"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 58-60"
    zoneMinMax["Stratholme (Main Gate)"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 58-60"
    zoneMinMax["Stratholme (Service Gate)"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 58-60"
    zoneMinMax["Gnomeregan"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 29-38"
    zoneMinMax["Temple of Atal'Hakkar"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 50-56"
    zoneMinMax["The Stockade"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 24-32"
    zoneMinMax["Razorfen Kraul"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 29-38"
    zoneMinMax["Razorfen Downs"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 37-46"
    zoneMinMax["Maraudon"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 46-55"
    zoneMinMax["Dire Maul"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 55-60"
    zoneMinMax["Zul'Farrak"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 42-46"
    zoneMinMax[" Ragefire Chasm"] = "\n|cFFFFFF00Questing Range:|r" .. orange .. " 13-18"

    table.insert(botdcore.instances, "Blackfathom Deeps")
    table.insert(botdcore.instances, "Uldaman")
    table.insert(botdcore.instances, "Wailing Caverns")
    table.insert(botdcore.instances, "The Deadmines")
    table.insert(botdcore.instances, "Scarlet Monastery")
    table.insert(botdcore.instances, "Shadowfang Keep")
    table.insert(botdcore.instances, "Scholomance")
    table.insert(botdcore.instances, "Stratholme (Main Gate)")
    table.insert(botdcore.instances, "Stratholme (Service Gate)")
    table.insert(botdcore.instances, "Gnomeregan")
    table.insert(botdcore.instances, "Temple of Atal'Hakkar")
    table.insert(botdcore.instances, "Stormwind Stockade")
    table.insert(botdcore.instances, "Razorfen Kraul")
    table.insert(botdcore.instances, "Razorfen Downs")
    table.insert(botdcore.instances, "Maraudon")
    table.insert(botdcore.instances, "Dire Maul")
    table.insert(botdcore.instances, "Zul'Farrak")
    table.insert(botdcore.instances, "Ragefire Chasm")
end

function botdcore.SetupInstanceKey()
    InstanceKey["The Deadmines"] =
        "Key - The Deadmines\n0. Entrance(outside instance)\n1. Marisa du'Paige(outside instance)\n2. Brainwashed Noble(outside instance)\n" ..
        "3. Foreman Thistlenettle(outside instance)\n4. Instance portal\n5. Rhahk'Zor\n6. Miner Johnson\n7. Sneed & Sneed's Shredder\n" ..
            "8. Gilnid\n9. Defias Gunpowder\n10. Mr. Smite\n11. Cookie\n12. Captain Greenskin\n13. Edwin VanCleef\n14. Exit"

    InstanceKey["Stormwind Stockade"] =
        "Key - The Stockade\nA. Entrance(outside instance)\n1. Targorr the Dead(Varies)\n2. Kam Deepfury\n3. Hamhock\n4. Bazil Thredd\n5. Textern Ward\n" ..
        "6. Bruegal Ironknuckle(Rare)"

    InstanceKey["Razorfen Kraul"] =
        "Key - The Deadmines\nA. Entrance(outside instance)\n1. Roogug\n2. Age Thorncurse\n3. Death Speaker Jargba\n4. Overlord Ramtusk\n4a. Razorfen Spearhide(Rare)\n" ..
        "5. Agathelos the Raging\n6. Blind Hunter(Rare)\n7. Charlga Razorflank\n8. Willix the Importer\n8a. Heralath Fallowbrook\n9. Earthcaller Halmgar(Rare)"

    InstanceKey["Gnomeregan"] =
        "Key - Gnomeregan\n1. Grubbis \n    (Spawns during the cave encounter)\n2. Viscous Fallout \n    (Bottom floor of the Hall of Gears)" ..
        "\n3. Electrocutioner 6000 \n    (Center of upper area inside Launch Bay)\n4. Crowd Pummeler 9-60 \n    (Upper area of the Engineering Labs)" ..
            "\n5. Dark Iron Ambassador \n    (Rare spawn in the last tunnel)\n6. Mekgineer Thermaplugg \n    (Center of the Tinkers' Court)"

    InstanceKey["Shadowfang Keep"] =
        "Key - Shadowfang Keep\n    COMING SOON.."

    InstanceKey["Blackfathom Deeps"] =
        "Key - Blackfathom Deeps\nA. Entrance\n1. Ghamoo-ra\n2. Lorgalis Manuscript" ..
        "\n3. Lady Sarevess\n4. Argent Guard Thaelrid" ..
        "\n5. Gelihast \n    (Shrine of Gelihast)\n6. Lorgus Jett \n    (Varies)"..
        "\n7. Baron Aquanis \n    (Fathom Stone)\n8. Twilight Lord Kelris"..
        "\n9. Old Serra'kis\n10. Aku'mai\n    (Morridune)\n    (Altar of the Deeps)"


    InstanceKey["Scarlet Monastery"] =
    "Key - Scarlet Monastery\nA. Entrance(Library)\nA. Entrance(Armory)\nA. Entrance(Cathedral)\nA. Entrance(Graveyard)\n1. Houndmaster Loksey\n2. Arcanist Doan" ..
    "\n3. Herod\n4. High Inquisitor Fairbanks" ..
    "\n5. Scarlet Commander Mograine \n    (High Inquisitor Whitemane)\n6. Ironspine \n    (Rare)"..
    "\n7. Azshir the Sleepless \n    (Rare)\n8. Twilight Lord Kelris"..
    "\n9. Bloodmage Thalnos"

end

--[[
Key - The Deadmines
0. Entrance
Marisa du'Paige (outside instance)
Brainwashed Noble (outside instance)
Foreman Thistlenettle (outside instance)
Instance portal
Rhahk'Zor
Miner Johnson
Sneed & Sneed's Shredder
Gilnid
Defias Gunpowder
Mr. Smite
Cookie
Captain Greenskin
Edwin VanCleef
Exit
]]
