--[[
	## BoTD Group WoW Classic Addon 
	## 10/13/2019
	## Brandon Autry
	## brandon@bitdraft.com
	## Vers: [Beta v0.3.2.6]
	## botdprofessionss.lua 
	]]
--------------------------------------
-- Namespaces
--------------------------------------

local addonName, botdcore = ...
-- Text colors
orange = "|cffFF8C00"
darkgrey = "|cffA9A9A9"
purple = "|cff8A2BE2"
white = "|cFFFFFFFF"
red = "|cFFFF0000"
green = "|cFF4ddb00"


tin = "|cFFd3d4d5Tin|r"
silver = "|cFFD3D3D3Silver|r"
iron = "|cFFcbcdcdIron|r"
gold = "|cFFFFD700Gold|r"
mithril = "|cFFb5b5bdMithril|r"
trueSilver = "|cFFD3D3D3TrueSilver|r"
copper = "|cFFb87333Copper|r"
thorium = "|cFF00ffccThorium|r"
-- Strings
version = "[0.3.2.6]" --Version Number

botdcore.PlayerProfessionOne = ""
botdcore.PlayerProfessionTwo = ""
botdcore.PlayerProfessionThree = ""
botdcore.PlayerProfessionFour = ""
botdcore.PlayerProfessionFive = ""


botdcore.PlayerProfessionOneLvl = ""
botdcore.PlayerProfessionTwoLvl = ""
botdcore.PlayerProfessionThreeLvl = ""
botdcore.PlayerProfessionFourLvl = ""
botdcore.PlayerProfessionFiveLvl = ""

ProfessionTable = {
    "Alchemy",
    "Find Herbs",
    "Blacksmithing",
    "Enchanting",
    "Engineering",
    "Leatherworking",
    "Find Minerals",
    "Skinning",
    "Tailoring",
    "Fishing",
    "Cooking",
    "First Aid"
}

--[[
Apprentice - up to 75
Journeyman - up to 150
Expert - up to 225
Artisan - up to 300
]]

function botdcore.GetProfessionLevel(name)				-- Get a profession's level
	local numSkills = GetNumSkillLines();
	for i=1, numSkills do
		local skillname,_,_,skillrank,_,skillmodifier = GetSkillLineInfo(i)
		if skillname:lower() == name:lower() then
			return skillrank
		end
	end
end
function botdcore.GetProfessions()
    for k, v in pairs(ProfessionTable) do
        ProfName, Subtext = GetSpellBookItemName(v)
        if (ProfName == "Find Herbs") then
            ProfName = "Herbalism"
        elseif (ProfName == "Find Minerals") then
            ProfName = "Mining"
        end
        if (ProfName ~= nil and ProfName ~= "") then
            if ((botdcore.PlayerProfessionOne == nil or botdcore.PlayerProfessionOne == "") and ProfName ~= botdcore.PlayerProfessionTwo) then
                local skill = botdcore.GetProfessionLevel(ProfName)
                botdcore.PlayerProfessionOne = ProfName
                botdcore.PlayerProfessionOneLvl = Subtext
            elseif ((botdcore.PlayerProfessionTwo == nil or botdcore.PlayerProfessionTwo == "") and ProfName ~= botdcore.PlayerProfessionOne and ProfName ~= botdcore.PlayerProfessionThree and ProfName ~= botdcore.PlayerProfessionFour) then
                local skill = botdcore.GetProfessionLevel(ProfName)
                botdcore.PlayerProfessionTwo = ProfName
                botdcore.PlayerProfessionTwoLvl = Subtext
            elseif ((botdcore.PlayerProfessionThree == nil or botdcore.PlayerProfessionThree == "") and ProfName ~= botdcore.PlayerProfessionOne and ProfName ~= botdcore.PlayerProfessionTwo and ProfName ~= botdcore.PlayerProfessionFour) then
                local skill = botdcore.GetProfessionLevel(ProfName)
                botdcore.PlayerProfessionThree = ProfName
                botdcore.PlayerProfessionThreeLvl = Subtext
            elseif ((botdcore.PlayerProfessionFour == nil or botdcore.PlayerProfessionFour == "") and ProfName ~= botdcore.PlayerProfessionOne and ProfName ~= botdcore.PlayerProfessionTwo and ProfName ~= botdcore.PlayerProfessionThree and ProfName ~= botdcore.PlayerProfessionFive) then
                local skill = botdcore.GetProfessionLevel(ProfName)
                botdcore.PlayerProfessionFour = ProfName
                botdcore.PlayerProfessionFourLvl = Subtext
            elseif ((botdcore.PlayerProfessionFive == nil or botdcore.PlayerProfessionFive == "") and ProfName ~= botdcore.PlayerProfessionOne and ProfName ~= botdcore.PlayerProfessionTwo and ProfName ~= botdcore.PlayerProfessionThree and ProfName ~= botdcore.PlayerProfessionFour) then
                local skill = botdcore.GetProfessionLevel(ProfName)
                botdcore.PlayerProfessionFive = ProfName
                botdcore.PlayerProfessionFiveLvl = Subtext
            end
        end
    end
end

function botdcore.ShowMiningLocations()
    --Professions Mining
    zoneMiningMinMax["Alterac Mountains"] = ""
    zoneMiningMinMax["Arathi Highlands"] = "\n".."|cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Badlands"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Blasted Lands"] = "\n".."|cFFD3D3D3TrueSilver|r, |cFF00ffccThorium|r"
    zoneMiningMinMax["Burning Steppes"] = "\n".."|cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Deadwind Pass"] = ""
    zoneMiningMinMax["Dun Morogh"] = "\n".."|cFFb87333Copper|r"
    zoneMiningMinMax["Duskwood"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r".."(rare)"
    zoneMiningMinMax["Eastern Plaguelands"] = "\n".."|cFFcbcdcdIron|r, |cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Elwynn Forest"] = "\n".."|cFFb87333Copper|r"
    zoneMiningMinMax["Hillsbrad Foothills"] = "\n".."|cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r"
    zoneMiningMinMax["Ironforge"] = ""
    zoneMiningMinMax["Loch Modan"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r"
    zoneMiningMinMax["Redridge Mountains"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r".."(rare)"
    zoneMiningMinMax["Searing Gorge"] = "\n".."|cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Silverpine Forest"] = "\n".."|cFFb87333Copper|r"
    zoneMiningMinMax["Stormwind City"] = ""
    zoneMiningMinMax["Stranglethorn Vale"] = "\n".."|cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r"
    zoneMiningMinMax["Northern Stranglethorn"] = "\n".."|cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r"
    zoneMiningMinMax["The Cape of Stranglethorn"] = "\n".."|cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r"
    zoneMiningMinMax["Swamp of Sorrows"] = "\n".."|cFFD3D3D3TrueSilver|r, |cFF00ffccThorium|r"
    zoneMiningMinMax["The Hinterlands"] = "\n".."|cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFD3D3D3TrueSilver|r, |cFF00ffccThorium|r"
    zoneMiningMinMax["Tirisfal Glades"] = "\n".."|cFFb87333Copper|r"
    zoneMiningMinMax["Undercity"] = ""
    zoneMiningMinMax["Westfall"] = "\n".."|cFFb87333Copper|r"
    zoneMiningMinMax["Western Plaguelands"] = "\n".."|cFFcbcdcdIron|r, |cFFFFD700Gold|r"
    zoneMiningMinMax["Wetlands"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r"

    -- Kalimdor
    zoneMiningMinMax["Ashenvale"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r".."(rare)"
    zoneMiningMinMax["Azshara"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r"
    zoneMiningMinMax["Darkshore"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r"
    zoneMiningMinMax["Darnassus"] = ""
    zoneMiningMinMax["Desolace"] = "\n".."|cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r"
    zoneMiningMinMax["Durotar"] = "\n".."|cFFb87333Copper|r"
    zoneMiningMinMax["Dustwallow Marsh"] = "\n".."|cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Felwood"] = "\n".."|cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r, |cFF00ffccThorium|r"
    zoneMiningMinMax["Feralas"] = "\n".."|cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Moonglade"] = ""
    zoneMiningMinMax["Mulgore"] = "\n".."|cFFb87333Copper|r"
    zoneMiningMinMax["Orgrimmar"] = ""
    zoneMiningMinMax["Silithus"] = "\n".."|cFFD3D3D3TrueSilver|r, |cFF00ffccThorium|r"
    zoneMiningMinMax["Stonetalon Mountains"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r"--..iron..", "..mithril
    zoneMiningMinMax["The Charred Vale"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r, "..iron..", "..mithril
    zoneMiningMinMax["Tanaris"] = "\n".."|cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Teldrassil"] = ""
    zoneMiningMinMax["The Barrens"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r"
    zoneMiningMinMax["Northern Barrens"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r"
    zoneMiningMinMax["Southern Barrens"] = "\n".."|cFFb87333Copper|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r"
    zoneMiningMinMax["Thousand Needles"] = "\n".."|cFFb87333Copper|r, |cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Thunder Bluff	"] = ""
    zoneMiningMinMax["Un'Goro Crater"] = "\n".."|cFFFFD700Gold|r, |cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r, |cFF00ffccThorium|r"
    zoneMiningMinMax["Winterspring"] = "\n".."|cFFD3D3D3TrueSilver|r, |cFF00ffccThorium|r"

    --Dungeons
    zoneMiningMinMax["Blackfathom Deeps"] = "\n".."|cFFd3d4d5Tin|r"
    zoneMiningMinMax["Uldaman"] = ":\n|cFFD3D3D3Silver|r, |cFFcbcdcdIron|r, |cFFb5b5bdMithril|r"
    zoneMiningMinMax["Wailing Caverns"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r"
    zoneMiningMinMax["The Deadmines"] = "\n".."|cFFb87333Copper|r, |cFFd3d4d5Tin|r, |cFFD3D3D3Silver|r"
    zoneMiningMinMax["Scarlet Monastery"] = ""
    zoneMiningMinMax["Shadowfang Keep"] = ""
    zoneMiningMinMax["Scholomance"] = ""
    zoneMiningMinMax["Stratholme (Main Gate)"] = ""
    zoneMiningMinMax["Stratholme (Service Gate)"] = ""
    zoneMiningMinMax["Gnomeregan"] = ""
    zoneMiningMinMax["Temple of Atal'Hakkar"] = ""
    zoneMiningMinMax["The Stockade"] = ""
    zoneMiningMinMax["Razorfen Kraul"] = "\n".."|cFFcbcdcdIron|r"
    zoneMiningMinMax["Razorfen Downs"] = ""
    zoneMiningMinMax["Maraudon"] = "\n".."|cFFb5b5bdMithril|r, |cFFD3D3D3TrueSilver|r"
    zoneMiningMinMax["Dire Maul"] = "\n".."|cFF00ffccThorium|r".."(rich)"
    zoneMiningMinMax["Zul'Farrak"] = ""
    zoneMiningMinMax["Ragefire Chasm"] = ""
end
