--[[
	## BoTD Group WoW Classic Addon 
	## 10/13/2019
	## Brandon Autry
	## brandon@bitdraft.com
	## Vers: [Beta v0.3.2.6]
	## botdquesthelper.lua 
	]]
--------------------------------------
-- Namespaces
--------------------------------------

local addonName, botdcore = ...
-- Text colors
orange = "|cffFF8C00"
darkgrey = "|cffA9A9A9"
purple = "|cff8A2BE2"
white = "|cFFFFFFFF"
red = "|cFFFF0000"
green = "|cFF4ddb00"

tin = "|cFFd3d4d5Tin|r"
silver = "|cFFD3D3D3Silver|r"
iron = "|cFFcbcdcdIron|r"
gold = "|cFFFFD700Gold|r"
mithril = "|cFFb5b5bdMithril|r"
trueSilver = "|cFFD3D3D3TrueSilver|r"
copper = "|cFFb87333Copper|r"
thorium = "|cFF00ffccThorium|r"

botdcore.BoTDQuest = {}
quests = {}
function botdcore.BoTDQuest:Create(_title, _level, _questID, _objectiveType, _objectiveText, _itemCount)
    local quest = {
        name = _title,
        level = _level,
        questID = _questID,
        objectiveType = _objectiveType,
        objectiveText = _objectiveText,
        itemCount = _itemCount
    }
    return quest
end

local function SearchTableForValue(chTable, checkObject)
    for checkInd, checkVal in ipairs(chTable) do
        if (checkObject == checkVal) then
            return true
        end -- (checkObject == checkVal) STMT
    end -- End for LOOP
    return false
end -- End lcl SearchTableForValue Function
local function SearchTableForPlayerName(chTable, itemname)
    for checkInd, checkVal in ipairs(chTable) do
        if (itemname == checkVal.name) then
            return true
        end -- (characterName == checkVal) STMT
    end -- End for LOOP
    return false
end -- End lcl SearchTableForValue Function

function botdcore.QuestPartyDropCountAlert(playername, lootedItem)
    numEntries, numQuests = GetNumQuestLogEntries()
    for index = 1, numEntries do
        title, level, _, isHeader, _, isComplete, _, questId, _, displayQuestId, _, _, _, _, _, _, _ =
            GetQuestLogTitle(index)

        if (not isHeader) then
            local logId = GetQuestLogIndexByID(questId)
            local old = GetQuestLogSelection()
            SelectQuestLogEntry(logId)
            local count = GetNumQuestLeaderBoards()
            for i = 1, count do
                text, objectiveType, finished = GetQuestLogLeaderBoard(i, index)
                    itemName, itemCount = strsplit(":", text)
                    if (itemName == lootedItem) then
                        print(itemName)
                        itemCount = itemCount:gsub("%s+", "")
                        localQuest =
                            botdcore.BoTDQuest:Create(title, level, questId, objectiveType, objectiveText, itemCount)
                        -- check = SearchTableForValue(quests, localQuest)

                        table.insert(quests, localQuest)
                        -- msg = UnitName("player").." has "..itemCount.." of ".. itemName
                        -- print(msg)
                        -- isOnQuest = IsUnitOnQuest(index, playerName) -- Returns whether a player is on this current quest(Within your party)
                        -- if (isOnQuest) then -- If a player is on the quest
                        -- itemCount = itemCount + 1
                        inInventory, itemTotal = strsplit("/", itemCount)
                        inInventory = inInventory + 1
                        myCount = inInventory .. "/" .. itemTotal
                        msg =
                            "[BoTD] " ..
                            version .. ": " .. UnitName("player") .. " has " .. myCount .. " of " .. itemName
                        if (tonumber(inInventory) < tonumber(itemTotal) and not finished) or (tonumber(inInventory) == 1 and tonumber(itemTotal) == 1) then
                            SendChatMessage(msg, "PARTY", nil, UnitName("player"))
                        elseif finished or tonumber(inInventory) == tonumber(itemTotal) then
                            msg =
                            "[BoTD] " ..
                            version .. ": " .. UnitName("player") .. " has collected all " .. itemName
                            SendChatMessage(msg, "PARTY", nil, UnitName("player"))
                        end
                    end
            end
        end
    end
end

function botdcore.QuestPartyMonsterKillCountAlert(playername, monsterKilled)
    numEntries, numQuests = GetNumQuestLogEntries()
    for index = 1, numEntries do
        title, level, _, isHeader, _, isComplete, _, questId, _, displayQuestId, _, _, _, _, _, _, _ =
            GetQuestLogTitle(index)
        if (not isHeader) then
            local logId = GetQuestLogIndexByID(questId)
            local old = GetQuestLogSelection()
            SelectQuestLogEntry(logId)
            local count = GetNumQuestLeaderBoards()
            for i = 1, count do
                text, objectiveType, finished = GetQuestLogLeaderBoard(i, index)
                if(objectiveType == "monster") then
                    itemName, itemCount = strsplit(":", text)
                    itemName = itemName:gsub(" slain", "")
                    if (itemName == monsterKilled) then
                        itemCount = itemCount:gsub("%s+", "")
                        inInventory, itemTotal = strsplit("/", itemCount)
                        inInventory = inInventory + 1
                        myCount = inInventory .. "/" .. itemTotal
                        msg =
                            "[BoTD] " ..
                            version .. ": " .. UnitName("player") .. " has killed " .. myCount .." ".. itemName.."'s"
                        if tonumber(inInventory) < tonumber(itemTotal) and not finished then
                            SendChatMessage(msg, "PARTY", nil, UnitName("player"))
                        elseif finished or tonumber(inInventory) == tonumber(itemTotal) then
                            msg =
                            "[BoTD] " ..
                            version .. ": " .. UnitName("player") .. " is finished killing " .. itemName.."'s"
                            SendChatMessage(msg, "PARTY", nil, UnitName("player"))
                        end
                    end
                else
                end
            end
        end

    end
end